* Dget.F
* the four-point tensor coefficients
* this file is part of LoopTools
* last modified 18 Oct 01 th

#include "defs.h"


	integer function Dget(p1, p2, p3, p4, p1p2, p2p3,
     +    m1, m2, m3, m4)
	implicit none
	double precision p1, p2, p3, p4, p1p2, p2p3
	double precision m1, m2, m3, m4

	integer cachelookup
	external cachelookup, Dijkl

	double precision para(10)

	double precision Dcache(2)
	common /Dbase/ Dcache

* The following data statement initializes two *pointers* to NULL
* (see cache.c). This is sneaky but ok because IEEE says 0D0 is
* represented as 8 0-bytes.
	data Dcache /0, 0/

	para(1) = p1
	para(2) = p2
	para(3) = p3
	para(4) = p4
	para(5) = p1p2
	para(6) = p2p3
	para(7) = m1
	para(8) = m2
	para(9) = m3
	para(10) = m4

	Dget = cachelookup(para, Dcache, Dijkl, 10, 46)
	end

************************************************************************

	subroutine Dijkl(P, D)
	implicit none
	double precision P(10)
	double complex D(46)

	double precision mw,gw,mw2
	double complex mwc
	common /resonant/ mwc

	integer Cget
	double complex D0
	external Cget, D0

	double complex Ccache(1)
	common /Cbase/ Ccache

	XREAL f1, f2, f3, det3
	XREAL M11, M12, M13, M22, M23, M33
	double complex s1, s2, s3
	double complex c1, c2, c3, c4, c5
	integer C234, C134, C124, C123

	double complex D0resonant
	external D0resonant

#ifndef LANGUAGE_FORTRAN_90
	double complex lc1, lc2, lc3
	lc1() = dcmplx(
     +    M11*dble(s1) + M12*dble(s2) + M13*dble(s3),
     +    M11*dimag(s1) + M12*dimag(s2) + M13*dimag(s3))
	lc2() = dcmplx(
     +    M12*dble(s1) + M22*dble(s2) + M23*dble(s3),
     +    M12*dimag(s1) + M22*dimag(s2) + M23*dimag(s3))
	lc3() = dcmplx(
     +    M13*dble(s1) + M23*dble(s2) + M33*dble(s3),
     +    M13*dimag(s1) + M23*dimag(s2) + M33*dimag(s3))
#endif

	mw = dreal(mwc)
	gw = -dimag(mwc)*2d0
	mw2=mw*mw


	f1 = .5D0*(QEXT(P(1)) + QEXT(P(5)) - P(2))
	f2 = .5D0*(QEXT(P(1)) + QEXT(P(4)) - P(6))
	f3 = .5D0*(QEXT(P(5)) + QEXT(P(4)) - P(3))
	M22 = QEXT(P(1))*P(4) - f2*f2
	M23 = f1*f2 - P(1)*f3
	det3 = 2*(P(5)*M22 - P(4)*f1*f1 + f3*(f1*f2 + M23))
	M11 = (QEXT(P(4))*P(5) - f3*f3)/det3
	M12 = (f2*f3 - P(4)*f1)/det3
	M13 = (f1*f3 - P(5)*f2)/det3
	M22 = M22/det3
	M23 = M23/det3
	M33 = (QEXT(P(1))*P(5) - f1*f1)/det3

	f1 = QEXT(P(1)) + QEXT(P(7)) - P(8)
	f2 = QEXT(P(5)) + QEXT(P(7)) - P(9)
	f3 = QEXT(P(4)) + QEXT(P(7)) - P(10)

	C234 = Cget(P(2), P(3), P(6), P(8), P(9), P(10))
	C134 = Cget(P(5), P(3), P(4), P(7), P(9), P(10))
	C124 = Cget(P(1), P(6), P(4), P(7), P(8), P(10))
	C123 = Cget(P(1), P(2), P(5), P(7), P(8), P(9))

	c1 = Ccache(C234 + cc0) + Ccache(C234 + cc1) +
     +    Ccache(C234 + cc2)
	c2 = Ccache(C234 + cc12) + Ccache(C234 + cc22) +
     +    Ccache(C234 + cc2)
	c3 = 2*(Ccache(C234 + cc1) + c2) + Ccache(C234 + cc11) -
     +    Ccache(C234 + cc22) + Ccache(C234 + cc0)
	c4 = Ccache(C234 + cc1) + Ccache(C234 + cc11) +
     +    Ccache(C234 + cc12)
	c5 = Ccache(C234 + cc111) + Ccache(C234 + cc112) +
     +    Ccache(C234 + cc11)





	if (P(1).eq.P(7).and.P(6).eq.P(10).and.P(8).eq.0.and.P(9).eq.mw2) then

	    D(dd0) = D0resonant(P(2),P(4),P(1),P(6),mw,gw)
*	    print*,'bos res 1=',gw

	else if (P(5).eq.P(7).and.P(3).eq.P(10).and.P(9).eq.0.and.P(8).eq.mw2) then

	    D(dd0) = D0resonant(P(2),P(4),P(3),P(5),mw,gw)
*	    print*,'bos res 2=',gw

	else

	D(dd0) = D0(P(1), P(2), P(3), P(4), P(5), P(6),
     +    P(7), P(8), P(9), P(10))


*	    print*,'bos vero =',D(dd0)
	end if
	s1 = Ccache(C134 + cc0) - Ccache(C234 + cc0) - f1*D(dd0)
	s2 = Ccache(C124 + cc0) - Ccache(C234 + cc0) - f2*D(dd0)
	s3 = Ccache(C123 + cc0) - Ccache(C234 + cc0) - f3*D(dd0)
	D(dd1) = lc1()
	D(dd2) = lc2()
	D(dd3) = lc3()

	D(dd00) = P(7)*D(dd0) + .5D0*(Ccache(C234 + cc0) +
     +    D(dd1)*f1 + D(dd2)*f2 + D(dd3)*f3)
	s1 = c1 - f1*D(dd1) - 2*D(dd00)
	s2 = Ccache(C124 + cc1) + c1 - f2*D(dd1)
	s3 = Ccache(C123 + cc1) + c1 - f3*D(dd1)
	D(dd11) = lc1()
	s1 = Ccache(C134 + cc1) - Ccache(C234 + cc1) - f1*D(dd2)
	s2 = -(Ccache(C234 + cc1) + f2*D(dd2)) - 2*D(dd00)
	s3 = Ccache(C123 + cc2) - Ccache(C234 + cc1) - f3*D(dd2)
	D(dd12) = lc1()
	D(dd22) = lc2()
	s1 = Ccache(C134 + cc2) - Ccache(C234 + cc2) - f1*D(dd3)
	s2 = Ccache(C124 + cc2) - Ccache(C234 + cc2) - f2*D(dd3)
	s3 = -(Ccache(C234 + cc2) + f3*D(dd3)) - 2*D(dd00)
	D(dd13) = lc1()
	D(dd23) = lc2()
	D(dd33) = lc3()

	s1 = Ccache(C134 + cc00) - Ccache(C234 + cc00) - f1*D(dd00)
	s2 = Ccache(C124 + cc00) - Ccache(C234 + cc00) - f2*D(dd00)
	s3 = Ccache(C123 + cc00) - Ccache(C234 + cc00) - f3*D(dd00)
	D(dd001) = lc1()
	D(dd002) = lc2()
	D(dd003) = lc3()
	s1 = -f1*D(dd11) - c3 - 4*D(dd001)
	s2 = Ccache(C124 + cc11) - f2*D(dd11) - c3
	s3 = Ccache(C123 + cc11) - f3*D(dd11) - c3
	D(dd111) = lc1()
	D(dd112) = lc2()
	D(dd113) = lc3()
	s1 = Ccache(C134 + cc11) - Ccache(C234 + cc11) - f1*D(dd22)
	s2 = -(Ccache(C234 + cc11) + f2*D(dd22)) - 4*D(dd002)
	s3 = Ccache(C123 + cc22) - Ccache(C234 + cc11) - f3*D(dd22)
	D(dd122) = lc1()
	D(dd222) = lc2()
	D(dd223) = lc3()
	s1 = Ccache(C134 + cc22) - Ccache(C234 + cc22) - f1*D(dd33)
	s2 = Ccache(C124 + cc22) - Ccache(C234 + cc22) - f2*D(dd33)
	s3 = -(Ccache(C234 + cc22) + f3*D(dd33)) - 4*D(dd003)
	D(dd133) = lc1()
	D(dd233) = lc2()
	D(dd333) = lc3()
	s1 = c2 - f1*D(dd13) - 2*D(dd003)
	s2 = Ccache(C124 + cc12) + c2 - f2*D(dd13)
	s3 = c2 - f3*D(dd13) - 2*D(dd001)
	D(dd123) = lc2()

	D(dd0000) = (P(7)*D(dd00) + .5D0*(Ccache(C234 + cc00) +
     +    f1*D(dd001) + f2*D(dd002) + f3*D(dd003)))/3D0 + 1/36D0
	D(dd0011) = (P(7)*D(dd11) + .5D0*(c3 + f1*D(dd111) +
     +    f2*D(dd112) + f3*D(dd113)))/3D0
	D(dd0012) = (P(7)*D(dd12) - .5D0*(c4 - f1*D(dd112) -
     +    f2*D(dd122) - f3*D(dd123)))/3D0
	D(dd0013) = (P(7)*D(dd13) - .5D0*(c2 - f1*D(dd113) -
     +    f2*D(dd123) - f3*D(dd133)))/3D0
	D(dd0022) = (P(7)*D(dd22) + .5D0*(Ccache(C234 + cc11)+
     +    f1*D(dd122) + f2*D(dd222) + f3*D(dd223)))/3D0
	D(dd0023) = (P(7)*D(dd23) + .5D0*(Ccache(C234 + cc12)+
     +    f1*D(dd123) + f2*D(dd223) + f3*D(dd233)))/3D0
	D(dd0033) = (P(7)*D(dd33) + .5D0*(Ccache(C234 + cc22)+
     +    f1*D(dd133) + f2*D(dd233) + f3*D(dd333)))/3D0

	c3 = c2 + Ccache(C234 + cc112) + Ccache(C234 + cc122)
	c2 = c2 + c3 - Ccache(C234 + cc2) + Ccache(C234 + cc122) +
     +    Ccache(C234 + cc222)
	c4 = c4 + c1 + c2 + c3 + c4 + c5 + Ccache(C234 + cc12)

	s1 = c4 - f1*D(dd111) - 6*D(dd0011)
	s2 = Ccache(C124 + cc111) + c4 - f2*D(dd111)
	s3 = Ccache(C123 + cc111) + c4 - f3*D(dd111)
	D(dd1111) = lc1()
	D(dd1112) = lc2()
	D(dd1113) = lc3()
	s1 = -(c2 + f1*D(dd113)) - 4*D(dd0013)
	s2 = Ccache(C124 + cc112) - c2 - f2*D(dd113)
	s3 = -(c2 + f3*D(dd113)) - 2*D(dd0011)
	D(dd1123) = lc2()
	D(dd1133) = lc3()
	s1 = c5 - f1*D(dd122) - 2*D(dd0022)
	s2 = c5 - f2*D(dd122) - 4*D(dd0012)
	s3 = Ccache(C123 + cc122) + c5 - f3*D(dd122)
	D(dd1122) = lc1()
	D(dd1223) = lc3()
	s1 = Ccache(C134 + cc111) - Ccache(C234 + cc111) - f1*D(dd222)
	s2 = -(Ccache(C234 + cc111) + f2*D(dd222)) - 6*D(dd0022)
	s3 = Ccache(C123 + cc222) - Ccache(C234 + cc111) - f3*D(dd222)
	D(dd1222) = lc1()
	D(dd2222) = lc2()
	D(dd2223) = lc3()
	s1 = Ccache(C134 + cc122) - Ccache(C234 + cc122) - f1*D(dd233)
	s2 = -(Ccache(C234 + cc122) + f2*D(dd233)) - 2*D(dd0033)
	s3 = -(Ccache(C234 + cc122) + f3*D(dd233)) - 4*D(dd0023)
	D(dd1233) = lc1()
	D(dd2233) = lc2()
	s1 = Ccache(C134 + cc222) - Ccache(C234 + cc222) - f1*D(dd333)
	s2 = Ccache(C124 + cc222) - Ccache(C234 + cc222) - f2*D(dd333)
	s3 = -(Ccache(C234 + cc222) + f3*D(dd333)) - 6*D(dd0033)
	D(dd1333) = lc1()
	D(dd2333) = lc2()
	D(dd3333) = lc3()

#ifdef LANGUAGE_FORTRAN_90
	contains

	double complex function lc1()
	lc1 = dcmplx(
     +    M11*dble(s1) + M12*dble(s2) + M13*dble(s3),
     +    M11*dimag(s1) + M12*dimag(s2) + M13*dimag(s3))
	end function lc1

	double complex function lc2()
	lc2 = dcmplx(
     +    M12*dble(s1) + M22*dble(s2) + M23*dble(s3),
     +    M12*dimag(s1) + M22*dimag(s2) + M23*dimag(s3))
	end function lc2

	double complex function lc3()
	lc3 = dcmplx(
     +    M13*dble(s1) + M23*dble(s2) + M33*dble(s3),
     +    M13*dimag(s1) + M23*dimag(s2) + M33*dimag(s3))
	end function lc3
#endif
	end

	double complex function D0resonant(s,r,m1,m2,mw,gw)
	double precision s,r,m1,m2
	double precision MW,GW,lambda2
	double complex cli2,dummy

	integer ier,ipi12
	parameter (pi2=3.1415926**2)

	call ffzxdl(cli2,ipi12,dummy,(mw**2+r)/r,1,ier)
	lambda2 = getlambda()

        D0resonant = 1d0/(r*(mw*mw-dcmplx(0d0,gw*mw)-s))*
     -                (log(mw/sqrt(m1))**2+log(mw/sqrt(m2))**2+
     -                 2*log(-sqrt(m1)*sqrt(m2)/r)*
     -                   log((mw*mw-dcmplx(0d0,gw*mw)-s)/
     -                        mw/sqrt(lambda2))+
     -                 pi2/3d0+dble(cli2)+ipi12*pi2/12d0)

	end function D0resonant
