* B0.F
* the scalar two-point function
* this file is part of LoopTools
* last modified 23 Oct 02 th

#include "defs.h"
	double complex function B0res(p,mw,gw)
	implicit none
	double precision gw,mw,p,mw2
	double precision getmudim,getdelta
	double complex gwmw,b0res2

	external getmudim,getdelta
	gwmw = dcmplx(0d0,gw*mw)
!	gwmw = dcmplx(0d0,1.d-8)
	mw2=mw*mw
c	print*,'B0res---',getdelta()

	B0res = getdelta()+2+log(getmudim()/mw2)+
     -          (mw2/p-1d0)*log((mw2-p-gwmw)/mw2)
        end function B0res

	double complex function B0(p, m1, m2)
	implicit none
	double precision p, m1, m2

#if CHECK
	external B0_check
#endif

	integer ier
	double precision getmudim,getdelta
	external getmudim,getdelta

c	print*,'B0---',getdelta()

	ier = 0
	call ffxb0(B0, p, m1, m2, ier)

	if( ier .gt. MAX_DIGITS ) print *,
     +    "B0 lost ", ier, " digits (m1 = ", sqrt(m1), ")"

#if CHECK
	call check_B(B0, B0_check, "B0", p, m1, m2)
#endif
	end

************************************************************************

	subroutine b0sub(result, p, m1, m2)
	implicit none
	double complex result
	double precision p, m1, m2

	double complex B0
	external B0

	result = B0(p, m1, m2)
	end

