* B00.F
* the two-point tensor coefficient of g_{mu nu}
* this file is part of LoopTools
* last modified 23 Oct 02 th

#include "defs.h"

	double complex function B00res(p,mw,gw)
	implicit none
	double precision p,mw,gw,mw2
	double complex gwmw, B0, B0res

	external B0,B0res

	gwmw = dcmplx(0d0,gw*mw)
!	gwmw = dcmplx(0d0,1.d-8)
	mw2=mw*mw

	B00res = 1d0/3d0*(
     -           mw2/2d0*B0(0d0,mw2,mw2)+
     -           (p-mw2)/4d0/p*((-p+mw2)*B0res(p,mw,gw)-
     -                           mw2*B0(0d0,0d0,mw2))) +
     -           mw2/3d0-p/18d0



	end function B00res

	

	double complex function B00(p, m1, m2)
	implicit none
	double precision p, m1, m2
#include "../ff/ff.h"

	double complex a0i(2), b0p, b1p
	common /bsave/ a0i, b0p, b1p

	double complex B1
	external B1

#if CHECK
	external B00_check
#endif

	double complex b2(2)
	integer ier

	b1p = B1(p, m1, m2)
	ier = 0
	call ffxb2p(b2, b1p, b0p, a0i, p, m1, m2, fpij2, ier)

	if( ier .gt. MAX_DIGITS ) print *,
     +    "B00 lost ", ier, " digits (m1 = ", sqrt(m1), ")"

	B00 = b2(2)

#if CHECK
	call check_B(B00, B00_check, "B00", p, m1, m2)
#endif
	end

************************************************************************

	subroutine b00sub(result, p, m1, m2)
	implicit none
	double complex result
	double precision p, m1, m2

	double complex B00
	external B00

	result = B00(p, m1, m2)
	end

