      subroutine initPDFhorace
      include 'shared.inc'
      common/parametersforPDF/iset
      common/yminimo/ymin ! for x1,x2pdf sampling, changed in cuts!
c
      commentonpdfs = 'no comment (on PDFs)' ! max 50 characters
                         ! written also in the event dump file
c
* setting PDFs parameters....      
      if (iwhich.eq.1) then
         iset    = 1
         qpdfmin = 1.25d0
         qpdfmax = 1.d7
         xpdfmax = 1.d0
         xpdfmin = 1.d-5
     $        +1.d-10 ! to avoid a warning in mrstqed2004 routine
         commentonpdfs = 'MRST2004QED PDFs' ! max 50 characters
                         ! written also in the event dump file
      endif
      if (iwhich.eq.2) then
         iset = 3
         qpdfmin = 1.25d0
         qpdfmax = 1.d10
         xpdfmax = 1.d0
         xpdfmin = 1.d-6
         call SetCtq6(iset)
         commentonpdfs = 'CTEQ6 PDFs (with iset = 3)' ! max 50 characters
                         ! written also in the event dump file
      endif
      if (iwhich.ge.3) then
         qpdfmin = 1.25d0
         qpdfmax = 1.d10
         xpdfmax = 1.d0
         xpdfmin = 1.d-6
         commentonpdfs = 'LHAPDF interface' ! max 50 characters
                         ! written also in the event dump file
         print*,'SET CORRECTLY PDFs!!'
         stop

c         if (iwhich.eq.3) call initPDFsetByName('MRST2001E.LHgrid')
c         if (iwhich.eq.3) call initPDFsetByName('MRST2001E.LHpdf')

c         if (iwhich.eq.3) call initPDFsetByName('cteq6l.LHpdf')
c         if (iwhich.eq.4) call initPDFsetByName('cteq5m.LHgrid')
c         if (iwhich.eq.5) call initPDFsetByName('MRSTQED.LHgrid')
c         call InitPDF(0)
      endif
***
      ymin = xpdfmin*xpdfmin
      return
      end
*****************************************
      subroutine pdf_wrapper(x,s,up,down,aup,adown,str,ch,bot,glu,phot)
* This subroutine returns the pdf's for the ---> PROTON <---
* inputs are:
* x   -  momentum fraction
* s   -  pdf scale (GeV)
* outputs are:
* up     -  up quark (valence + sea) parton density function
* down   -  down quark (valence + sea) parton density function
* aup    -  anti-up quark parton density function
* adown  -  anti-down quark parton density function
* str    -  strange quark parton density function
* ch     -  charm quark parton density function
* bot    -  bottom quark parton density function
* glu    -  gluon parton density function
      include 'shared.inc'
      double precision f(-6:6)
      common/parametersforPDF/iset
      if (iwhich.eq.1) then
! updated 29/08/2005 for mrst 2004 qed parameterization
*  iwhich = 1 --> MRST QED parametrization....
! MRST subroutines return x * PDF and NOT PDF
!         call mrst2001(x,s,imrst,uv,dv,us,ds,stra,cha,bottom,gluon)
         call mrstqed(x,s,iset,uv,dv,us,ds,stra,cha,bottom,gluon,
     .        photon)
         up    = (uv+us)/x
         down  = (dv+ds)/x
         aup   = us/x
         adown = ds/x
         str   = stra/x
         ch    = cha/x
         bot   = bottom/x
         glu   = gluon/x
         phot  = photon/x * iphinduced
         return
      endif
      if (iwhich.eq.2) then 
*     iwhich = 2 --> CTEQ6 parametrization....
         up    =  Ctq6Pdf(1,x,s)
         down  =  Ctq6Pdf(2,x,s)
         aup   =  Ctq6Pdf(-1,x,s)
         adown =  Ctq6Pdf(-2,x,s)
         str   =  Ctq6Pdf(3,x,s)
         ch    =  Ctq6Pdf(4,x,s)
         bot   =  Ctq6Pdf(5,x,s)
         glu   =  Ctq6Pdf(0,x,s)
         phot  = 0.d0
         return
      endif
      if (iwhich.ge.3) then
         print*,'Set correctly the PDF set! '
         stop
c         call evolvePDF(x,s,f)
c         up    =  f(2)/x
c         down  =  f(1)/x
c         aup   =  f(-2)/x
c         adown =  f(-1)/x
c         str   =  f(3)/x
c         ch    =  f(4)/x
c         bot   =  f(5)/x
c         glu   =  f(0)/x
c         phot  = 0.d0
         return
      endif
      return
      end
