*          Form lavora nell'euclideo.
*  F  definizione per funzioni non-commutanti
*  CF definizione funzioni commutanti
*  V definizione vettori
*   S definizione dei simboli, oggetto senza indici.
*  I definizione indici (se non ci metti nulla lui li definisce in 4-dim)
*  g_(n,mu) e' la matrice gamma(u) con indice di 
*  traccia "n", n=intero, 1,2,etc
*  la traccia si fa con trace4,1..tracen,1 in n dimensioni.
*
*     bhabha radiativo....
*
*     propagator and vertices coefficients according to Mandl-Shaw
*
*************************************************************************
* Off statistics;

I a,mu1,mu,al,nu,m,al1,al2,it,nu1,nu2,nu3,nu4;

S p1q,p2q,p3q,p4q , mf, ma, mb;

S czh2,gv2,ga2,gv3,ga3,gv4,ga4,mf2,mf4,mf6,mm2,mm4,mm6;
S ovall;
S p1qm1,p2qm1,p3qm1,p4qm1,p1qm2,p2qm2,p3qm2,p4qm2;
S p1p22,p1p32,p1p42,p2p32,p2p42,p3p42;
S p1p2,p1p3,p1p4,p2p3,p2p4,p3p4;
S p1q,p2q,p3q,p4q;
S p1qm1,p2qm1,p3qm1,p4qm1;
S p1qm2,p2qm2,p3qm2,p4qm2;

S p1q2,p2q2,p3q2,p4q2,delta;
S sedici,trentadue,sessantaquattro;

S m1,m2,m3,m4,mz,gz;
S mzm2,mzm4,mzm6,mzm8;

S s12,s34,t24,t13,s12m1,s12m2,s34m1,s34m2,t24m1,t24m2,t13m1,t13m2;
S vp12,vp34,vp24,vp13;
S vp122,vp342,vp242,vp132;
S p1p2,p1p3,p1p4,p2p3,p2p4,p3p4;
S p1p22,p1p32,p1p42,p2p32,p2p42,p3p42;

S p2p4m1,p2p3m1;
S p1p3m1;
S p1p3m2,p2p3m2,e4;

Index i,j ;

V pz,p1,p2,p3,p4,q,pa,pb,k;
V pz12q,pz12,pz14q,pz14,pz32q,pz32,pz34q,pz34;

F A1A1d, A2A2d,
  A3A3d, A4A4d,
  A1dA2, A1A2d,
  A1dA3, A1A3d,
  A1dA4, A1A4d,
  A2dA3, A2A3d,
  A2dA4, A2A4d,
  A3dA4, A3A4d;

F del,delb,projm,projp,propz,propzd;
F r,rp,rpp,rt,rpt,rppt,r12,r12t,r34,r34t,r13,r13t,r24,r24t;

L elmat2= 
e4*(A1A1d)/4;
**

id,A1A1d = (p1p3m1*g_(1,mu)* (g_(1,p3)-g_(1,p1)+mf)*g_(1,nu) +
           p2p3m1*g_(1,nu)* (g_(1,p3)-g_(1,p2)+mf)*g_(1,mu))*
           (g_(1,p4) - mf)*
           (p2p3m1*g_(1,mu)* (-g_(1,p2)+g_(1,p3)+mf)*g_(1,nu) +
            p1p3m1*g_(1,nu)* (g_(1,p3)-g_(1,p1)+mf)*g_(1,mu))*
           (g_(1,p3) + mf);

trace4,1;

id, vp12^2 = vp122;
id, vp34^2 = vp342;
id, vp24^2 = vp242;
id, vp13^2 = vp132;


id, p1.p1 = 0;
id, p2.p2 = 0;
id, p3.p3 = mf^2;
id, p4.p4 = mf^2;

id, p1.q = p1q;
id, p2.q = p2q;
id, p3.q = p3q;
id, p4.q = p4q;

id, p1.q^-2 = p1qm2;
id, p2.q^-2 = p2qm2;
id, p3.q^-2 = p3qm2;
id, p4.q^-2 = p4qm2;

id, p1.q^-1 = p1qm1;
id, p2.q^-1 = p2qm1;
id, p3.q^-1 = p3qm1;
id, p4.q^-1 = p4qm1;

id, p1qm2*p1q = p1qm1;
id, p2qm2*p2q = p2qm1;
id, p3qm2*p3q = p3qm1;
id, p4qm2*p4q = p4qm1;

id, p1qm1*p1q = 1;
id, p2qm1*p2q = 1;
id, p3qm1*p3q = 1;
id, p4qm1*p4q = 1;


id, s12^-2 = s12m2;
id, s34^-2 = s34m2;
id, t13^-2 = t13m2;
id, t24^-2 = t24m2;

id, s12^-1 = s12m1;
id, s34^-1 = s34m1;
id, t13^-1 = t13m1;
id, t24^-1 = t24m1;

id, p1.p2 = p1p2;
id, p1.p3 = p1p3;
id, p1.p4 = p1p4;
id, p2.p3 = p2p3;
id, p2.p4 = p2p4;
id, p3.p4 = p3p4;

id, p1p2^2 = p1p22;
id, p1p3^2 = p1p32;
id, p1p4^2 = p1p42;
id, p2p3^2 = p2p32;
id, p2p4^2 = p2p42;
id, p3p4^2 = p3p42;

id, q.q = 0;

id, m1 = mf;
id, m2 = mf;
id, m3 = mf;
id, m4 = mf;

id, p1p3m1^2 = p1p3m2;
id, p2p3m1^2 = p2p3m2;

id, p1p3m2 * p1p3 = p1p3m1;
id, p2p3m2 * p2p3 = p2p3m1;

id, p1p3m1 * p1p3 = 1;
id, p2p3m1 * p2p3 = 1;

id, delta =-1;

** id, mf = 0;

id, mf^6 = mf6;
id, mf^4 = mf4;
id, mf^2 = mf2;

B mf6,mf4,mf2,e4,p1p3m2,p2p3m2,p1p3m1,p2p3m1;
*  vp122,vp342,vp242,vp132,vp12,vp34,vp24,vp13;

format doublefortran;
print;
.sort

.end
