      subroutine pdfsampling(s,spdf,w)
      include 'shared.inc'
      call get_x1x2pdf(s,pdfjac)
      if (boson.eq.'W') then 
         spdf = mw * rescalepdfscale
      else
         spdf = mz * rescalepdfscale
      endif
      call get_is(x1pdf,x2pdf,spdf,wpdfpdf)
      w = wpdfpdf*pdfjac
      return
      end
*******************      
      subroutine get_x1x2pdf(s,w)
      include 'shared.inc'
      real*4 rnd(2),csi(1)
      common/yminimo/ymin
      w = 1.d0
      if (i_pdf.ne.0) then
! I change the integration variables: from x1,x2 to x1,y=x1*x2 (--> x2=y/x1).
! The Jacobian of the transformation is 1/x1.
! Then I sample x1 (xmin < x1 < xmax) according to 1/x1 and y
! (x1*xmin <y < x1*xmax) according to a multi-channel BW or 1/y
         if (boson.eq.'Z') then
            am = mz
            ag = gz
            a  = 2.3d0
c            a  = 4.d0
         else
            am = mw
            ag = gw
            a    = 1.3d0
         endif

         ymax = xmax*xmax

         anbw = 1.d0/(s*am*ag)*( atan( ymax*s/am/ag-am/ag )
     >        - atan( ymin*s/am/ag-am/ag ) )

         uma  = 1.d0 - a
         an13 = 1.d0/uma*(ymax**uma - ymin**uma)

         pbw  = 0.5d0
c         pbw  = 0.d0
         pomy = 1.d0 - pbw

*     for y, I use a multi-channel sampling, in order to flatten both BW and
*     1/y (implied by PDFs) peaks.....         
         call wraprng(rnd,2)
         if (rnd(1).lt.pbw) then             
            y    = 1.d0*rnd(2)
            tmp  = atan(ymin*s/am/ag-am/ag)
            y    = ag*am/s*( tan(s*am*ag*anbw*y+tmp)+am/ag )
         else
c            y = ymin*exp(aln*rnd(2))            
c            y = (ymax-ymin)*rnd(2) + ymin ! flat...
            y = uma * an13 * rnd(2) + ymin**uma ! as y**-a
            y = y **(1.d0/uma)
         endif

         wbw  = 1.d0/anbw/((y*s-am**2)**2+am**2*ag**2)
c         womy = 1.d0/y/aln
c         womy = ymax-ymin  ! flat...
         womy  = 1.d0/an13/y**a

         regulator  = 1.d0/(pbw*wbw + pomy*womy)         
         w = w*regulator

c         x1min = y/xmax
         x1min = max(y/xmax,xmin)
c         x1max = xmax
         x1max = min(y/xmin,xmax)

         aln = log(x1max/x1min)
         call wraprng(csi,1)
         x1  = x1min*exp(aln*csi(1))
         w   = w * aln * x1

         yjac = 1/x1
         w    = w*yjac
         
         x1pdf = x1
         x2pdf = y/x1
*[[[[[[[[[[[[[
! simmetrizzo x1 x2, non e' cosi' necessario...
         rr = 1.d0/x1pdf
         call wraprng(csi,1)
         if (csi(1).lt.0.5) then
            x1    = x1pdf
            x1pdf = x2pdf
            x2pdf = x1
            rr = 1.d0/x2pdf
         endif
         w = w * 2.d0 /(1.d0/x1pdf+1.d0/x2pdf) * rr
*]]]]]]]]]]]]]
      else  ! if the partonic cross section is selected
         x1pdf  = 1.d0        
         x2pdf  = 1.d0
         w = 1.d0       
      endif
c      print*,x1pdf,x2pdf,x1min,x1max,xmin
      return
      end
**
      subroutine get_x1x2pdf_ANCORABCK(s,w)
      include 'shared.inc'
      real*4 rnd(2),csi(1)
      common/yminimo/ymin
      w = 1.d0
      if (i_pdf.ne.0) then
! I change the integration variables: from x1,x2 to x1,y=x1*x2 (--> x2=y/x1).
! The Jacobian of the transformation is 1/x1.
! Then I sample x1 (xmin < x1 < xmax) according to 1/x1 and y
! (x1*xmin <y < x1*xmax) according to a multi-channel BW or 1/y
         if (boson.eq.'Z') then
c            call get_x1x2pdf_OLD_OLD(s,w)
c            return
            am = mz
            ag = gz
            a  = 1.3d0
         else
            am = mw
            ag = gw
            a    = 1.3d0
c            call get_x1x2pdf_OLD_OLD(s,w)
c            return
         endif
*** PDFs go as ~1/x**1.3 for x --> 0 !!
**********
         ymax = xmax*xmax
         sshatmin = 2.d0*ebeam*sqrt(ymin)

         anbw = 1.d0/(s*am*ag)*( atan( ymax*s/am/ag-am/ag )
     >        - atan( ymin*s/am/ag-am/ag ) )
c         aln = log(ymax/ymin)


         uma  = 1.d0 - a
         an13 = 1.d0/uma*(ymax**uma - ymin**uma)

         pbw  = 0.9d0
c         if (sshatmin.gt.70d0.and.boson.eq.'W') pbw = 0.1d0
c         if (sshatmin.gt.80d0.and.boson.eq.'Z') pbw = 0.1d0
         pomy = 1.d0 - pbw

*     for y, I use a multi-channel sampling, in order to flatten both BW and
*     1/y (implied by PDFs) peaks.....         
         call wraprng(rnd,2)
         if (rnd(1).lt.pbw) then             
            y    = 1.d0*rnd(2)
            tmp  = atan(ymin*s/am/ag-am/ag)
            y    = ag*am/s*( tan(s*am*ag*anbw*y+tmp)+am/ag )
         else
c            y = ymin*exp(aln*rnd(2))            
c            y = (ymax-ymin)*rnd(2) + ymin ! flat...
            y = uma * an13 * rnd(2) + ymin**uma ! as y**-a
            y = y **(1.d0/uma)
         endif

         wbw  = 1.d0/anbw/((y*s-am**2)**2+am**2*ag**2)
c         womy = 1.d0/y/aln
c         womy = ymax-ymin  ! flat...
         womy  = 1.d0/an13/y**a

         regulator  = 1.d0/(pbw*wbw + pomy*womy)         
         w = w*regulator

         x1min = max(y/xmax,xmin)
         x1max = min(y/xmin,xmax)

         aln = log(x1max/x1min)
         call wraprng(csi,1)
         x1  = x1min*exp(aln*csi(1))
         w   = w * aln * x1
c         x1 = (x1max - x1min) * csi(1) + x1min
c         w  = w * (x1max -x1min)

         yjac = 1/x1
         w    = w*yjac
         
         x1pdf = x1
         x2pdf = y/x1
*[[[[[[[[[[[[[
! simmetrizzo x1 x2, non e' cosi' necessario...
         rr = 1.d0/x1pdf
         call wraprng(csi,1)
         if (csi(1).lt.0.5) then
            x1    = x1pdf
            x1pdf = x2pdf
            x2pdf = x1
            rr = 1.d0/x2pdf
         endif
         w = w * 2.d0 /(1.d0/x1pdf+1.d0/x2pdf) * rr
*]]]]]]]]]]]]]
      else  ! if the partonic cross section is selected
         x1pdf  = 1.d0        
         x2pdf  = 1.d0
         w = 1.d0       
      endif
      return
      end
**
*
      subroutine get_x1x2pdf_OLD(s,w)
      include 'shared.inc'
      real*4 rnd(2),csi(1)
      common/yminimo/ymin
      w = 1.d0
      if (i_pdf.ne.0) then
! I change the integration variables: from x1,x2 to x1,y=x1*x2 (--> x2=y/x1).
! The Jacobian of the transformation is 1/x1.
! Then I sample x1 (xmin < x1 < xmax) according to 1/x1 and y
! (x1*xmin <y < x1*xmax) according to a multi-channel BW or 1/y
         if (boson.eq.'Z') then
c            call get_x1x2pdf_OLD(s,w)
c            return
            am = mz
            ag = gz
         else
            am = mw
            ag = gw
c            call get_x1x2pdf_OLD(s,w)
c            return
         endif
*** PDFs go as ~1/x**1.3 for x --> 0 !!
**********
         ymax = xmax*xmax
         sshatmin = 2.d0*ebeam*sqrt(ymin)

         anbw = 1.d0/(s*am*ag)*( atan( ymax*s/am/ag-am/ag )
     >        - atan( ymin*s/am/ag-am/ag ) )
c         aln = log(ymax/ymin)
         a    = 1.3d0
         
         uma  = 1.d0 - a
         an13 = 1.d0/uma*(ymax**uma - ymin**uma)

         pbw  = 1.d0
         pbw  = 0.4d0
         if (sshatmin.gt.70d0.and.boson.eq.'W') pbw = 0.1d0
         if (sshatmin.gt.80d0.and.boson.eq.'Z') pbw = 0.1d0
         pomy = 1.d0 - pbw

*     for y, I use a multi-channel sampling, in order to flatten both BW and
*     1/y (implied by PDFs) peaks.....         
         call wraprng(rnd,2)
         if (rnd(1).lt.pbw) then             
            y    = 1.d0*rnd(2)
            tmp  = atan(ymin*s/am/ag-am/ag)
            y    = ag*am/s*( tan(s*am*ag*anbw*y+tmp)+am/ag )
         else
c            y = ymin*exp(aln*rnd(2))            
c            y = (ymax-ymin)*rnd(2) + ymin ! flat...
            y = uma * an13 * rnd(2) + ymin**uma ! as y**-a
            y = y **(1.d0/uma)
         endif

         wbw  = 1.d0/anbw/((y*s-am**2)**2+am**2*ag**2)
c         womy = 1.d0/y/aln
c         womy = ymax-ymin  ! flat...
         womy  = 1.d0/an13/y**a

         regulator  = 1.d0/(pbw*wbw + pomy*womy)         
         w = w*regulator

         x1min = max(y/xmax,xmin)
         x1max = min(y/xmin,xmax)

         aln = log(x1max/x1min)
         call wraprng(csi,1)
         x1  = x1min*exp(aln*csi(1))
         w   = w * aln * x1
c         x1 = (x1max - x1min) * csi(1) + x1min
c         w  = w * (x1max -x1min)

         yjac = 1/x1
         w    = w*yjac
         
         x1pdf = x1
         x2pdf = y/x1
*[[[[[[[[[[[[[
! simmetrizzo x1 x2, non e' cosi' necessario...
         rr = 1.d0/x1pdf
         call wraprng(csi,1)
         if (csi(1).lt.0.5) then
            x1    = x1pdf
            x1pdf = x2pdf
            x2pdf = x1
            rr = 1.d0/x2pdf
         endif
         w = w * 2.d0 /(1.d0/x1pdf+1.d0/x2pdf) * rr
*]]]]]]]]]]]]]
      else  ! if the partonic cross section is selected
         x1pdf  = 1.d0        
         x2pdf  = 1.d0
         w = 1.d0       
      endif
      return
      end
**
      subroutine get_x1x2pdf_OLD_OLD(s,w)
      include 'shared.inc'
      real*4 rnd(2),csi(1)
      w = 1.d0
      if (i_pdf.ne.0) then
! I change the integration variables: from x1,x2 to x1,y=x1*x2 (--> x2=y/x1).
! The Jacobian of the transformation is 1/x1.
! Then I sample x1 (xmin < x1 < xmax) according to 1/x1 and y
! (x1*xmin <y < x1*xmax) according to a multi-channel BW or 1/y
         if (boson.eq.'Z') then
            am = mz
            ag = gz
         else
            am = mw
            ag = gw
         endif

         aln = log(xmax/xmin)
         call wraprng(csi,1)
         x1  = xmin*exp(aln*csi(1))
         w = w * aln         
         anbw = 1.d0/(s*am*ag)*( atan( x1*xmax*s/am/ag-am/ag )
     >        - atan( x1*xmin*s/am/ag-am/ag ) )

         pbw = 0.5d0
         pomy = 1.d0 - pbw
 
*     for y, I use a multi-channel sampling, in order to flatten both BW and
*     1/y (implied by PDFs) peaks.....
         call wraprng(rnd,2)
         if (rnd(1).lt.pbw) then             
            y    = 1.d0*rnd(2)
            tmp  = atan(x1*xmin*s/am/ag-am/ag)
            y    = ag*am/s*( tan(s*am*ag*anbw*y+tmp)+am/ag )
         else
            y = x1*xmin*exp(aln*rnd(2))            
         endif
         wbw  = 1.d0/anbw/((y*s-am**2)**2+am**2*ag**2)
         womy = 1.d0/y/aln
         regulator  = 1.d0/(pbw*wbw + pomy*womy)
         w = w*regulator
         x1pdf = x1
         x2pdf = y/x1
         if (x1pdf.gt.0.999999) x1pdf = 0.999999  
         if (x2pdf.gt.0.999999) x2pdf = 0.999999  
      else  ! if the partonic cross section is selected
         x1pdf  = 1.d0        
         x2pdf  = 1.d0
         w = 1.d0       
      endif 
      return
      end
********************************************************************
      subroutine get_is(x1,x2,s,weight)
* This subroutine selects the initial state particles (storing the masses,
* the charges and type in the common string 'process')
      include 'shared.inc'
      common/getisfirst/igetis
      data igetis /1/
      if (igetis.eq.1) then
         do j = -ifl,ifl
            do i = -ifl,ifl
               pdfpdf(i,j) = 0.d0
               sezij(i,j)  = 0.d0
            enddo
         enddo
         igetis = 0
      endif
      call get_pdf(x1,x2,s)

      if (pdf1(0).gt.0.d0.or.pdf2(0).gt.0.d0) then
! a bit (~10%) slower, but with photon induced proc.
        call get_is_WZ(weight)
      else
! faster, but without photon induced proc.
         if (pdf1(0).lt.0.d0) pdf1(0) = 0.d0
         if (pdf2(0).lt.0.d0) pdf2(0) = 0.d0
         if (boson.eq.'W') then
            call get_is_W(x1,x2,s,weight)
         else
            call get_is_Z(x1,x2,s,weight)
         endif
      endif
      return
      end
********************************************************************
      subroutine get_is_WZ(weight)
! with photon induced, both for W and Z
      include 'shared.inc'
      real*4 rnd(1)
      common/getiswzcommon/ifirst,ii(-ifl:ifl,-ifl:ifl)
      parameter (nii = (2*ifl+1)*(2*ifl+1))
      data ii,ifirst /nii*0,1/
      if (boson.eq.'W') then
         ! init for W+
         ii(0,2)  = 0
         ii(0,4)  = 0
         ii(0,-1) = 0
         ii(0,-3) = 0
         ii(0,-5) = 0
         ii(2,0)  = 0
         ii(4,0)  = 0
         ii(-1,0) = 0
         ii(-3,0) = 0
         ii(-5,0) = 0
         ii(2,-1) = 0
         ii(2,-3) = 0
         ii(2,-5) = 0
         ii(4,-1) = 0
         ii(4,-3) = 0
         ii(4,-5) = 0
         ii(-1,2) = 0
         ii(-3,2) = 0
         ii(-5,2) = 0
         ii(-1,4) = 0
         ii(-3,4) = 0
         ii(-5,4) = 0
         ! init for W-
         ii(0,-2) = 0
         ii(0,-4) = 0
         ii(0,1)  = 0
         ii(0,3)  = 0
         ii(0,5)  = 0
         ii(-2,0) = 0
         ii(-4,0) = 0
         ii(1,0)  = 0
         ii(3,0)  = 0
         ii(5,0)  = 0
         ii(-2,1) = 0
         ii(-2,3) = 0
         ii(-2,5) = 0
         ii(-4,1) = 0
         ii(-4,3) = 0
         ii(-4,5) = 0
         ii(1,-2) = 0
         ii(3,-2) = 0
         ii(5,-2) = 0
         ii(1,-4) = 0
         ii(3,-4) = 0
         ii(5,-4) = 0
         if (chfs.gt.0.d0) then ! W+
            ii(0,2)  = iphinduced
            ii(0,4)  = iphinduced
            ii(0,-1) = iphinduced
            ii(0,-3) = iphinduced
            ii(0,-5) = iphinduced
            ii(2,0)  = iphinduced
            ii(4,0)  = iphinduced
            ii(-1,0) = iphinduced
            ii(-3,0) = iphinduced
            ii(-5,0) = iphinduced
            ii(2,-1) = 1
            ii(2,-3) = 1
            ii(2,-5) = 1
            ii(4,-1) = 1
            ii(4,-3) = 1
            ii(4,-5) = 1
            ii(-1,2) = 1
            ii(-3,2) = 1
            ii(-5,2) = 1
            ii(-1,4) = 1
            ii(-3,4) = 1
            ii(-5,4) = 1
         else                   ! W-
            ii(0,-2) = iphinduced
            ii(0,-4) = iphinduced
            ii(0,1)  = iphinduced
            ii(0,3)  = iphinduced
            ii(0,5)  = iphinduced
            ii(-2,0) = iphinduced
            ii(-4,0) = iphinduced
            ii(1,0)  = iphinduced
            ii(3,0)  = iphinduced
            ii(5,0)  = iphinduced
            ii(-2,1) = 1
            ii(-2,3) = 1
            ii(-2,5) = 1
            ii(-4,1) = 1
            ii(-4,3) = 1
            ii(-4,5) = 1
            ii(1,-2) = 1
            ii(3,-2) = 1
            ii(5,-2) = 1
            ii(1,-4) = 1
            ii(3,-4) = 1
            ii(5,-4) = 1
         endif
      else ! if boson = Z
         if (ifirst.eq.1) then
            ii(0,0)  = iphinduced
            ii(1,-1) = 1  !* 0
            ii(2,-2) = 1  !* 0
            ii(3,-3) = 1  !* 0
            ii(4,-4) = 1  !* 0
            ii(5,-5) = 1  !* 0
            ii(-1,1) = 1  !* 0
            ii(-2,2) = 1  !* 0
            ii(-3,3) = 1  !* 0
            ii(-4,4) = 1  !* 0
            ii(-5,5) = 1  !* 0
            ii(0,1)  = iphinduced  !* 0
            ii(0,2)  = iphinduced  !* 0
            ii(0,3)  = iphinduced  !* 0
            ii(0,4)  = iphinduced  !* 0
            ii(0,5)  = iphinduced  !* 0
            ii(0,-1) = iphinduced  !* 0
            ii(0,-2) = iphinduced  !* 0
            ii(0,-3) = iphinduced  !* 0
            ii(0,-4) = iphinduced  !* 0
            ii(0,-5) = iphinduced  !* 0
            ii(1,0)  = iphinduced  !* 0
            ii(2,0)  = iphinduced  !* 0
            ii(3,0)  = iphinduced  !* 0 
            ii(4,0)  = iphinduced  !* 0
            ii(5,0)  = iphinduced  !* 0
            ii(-1,0) = iphinduced  !* 0
            ii(-2,0) = iphinduced  !* 0
            ii(-3,0) = iphinduced  !* 0
            ii(-4,0) = iphinduced  !* 0
            ii(-5,0) = iphinduced  !* 0
         endif
      endif
      sumpdfpdf = 0.d0
      weight    = 0.d0
      do j = -ifl,ifl
         do i = -ifl,ifl
            if (ii(i,j).gt.0) then
               Vud2 = myckm(i,j)**2
               if (boson.eq.'Z') then 
                  Vud2 = 1.d0
               endif
               if (i_pdf.eq.0) Vud2 = 1.d0
!!! ATTENZIONE!!!
c               if (i.eq.0.or.j.eq.0) then 
c                  Vud2 = 1.d0   !! FOR THE MOMENT!!!
c               endif
!!! ATTENZIONE!!!
               if (pdf1(i).lt.0.d0) pdf1(i) = 0.d0
               if (pdf2(j).lt.0.d0) pdf2(j) = 0.d0
               if (boson.eq.'W') pdfpdf(-i,-j) = 0.d0
               pdfpdf(i,j) = pdf1(i)*pdf2(j)*Vud2
               sumpdfpdf = sumpdfpdf + pdfpdf(i,j)
            endif
         enddo
      enddo
* It can happen that the pdf product for a given x1, x2 is zero for all
* the particles. In this case, no process can occur: I keep ipart1 
* and ipart2 = ifl+1 and the routine exits
      if (sumpdfpdf.eq.0.d0) then        
         ipart1 = ifl + 1
         ipart2 = ifl + 1
         return
      endif
      weight = sumpdfpdf
* choose the process...
      i_stop = 0
      psum   = 0.d0
      call wraprng(rnd,1)
      j = -ifl-1
      do while(i_stop.eq.0.and.j.lt.ifl)
         j = j + 1
         i = -ifl - 1
         do while(i_stop.eq.0.and.i.lt.ifl)
            i = i + 1
            if (ii(i,j).gt.0) then
               psum   = psum + pdfpdf(i,j)
               psum_n = psum/sumpdfpdf               
               if (psum_n.gt.rnd(1)) then
                  m1  = mq(i)
                  m2  = mq(j)
                  ch1 = chq(i)
                  ch2 = chq(j)
                  ipart1 = i
                  ipart2 = j               
                  i_stop = 1
               endif
            endif
         enddo
      enddo
      ifirst = 0
      return
      end
************************
      subroutine get_is_W(x1,x2,s,weight)
      include 'shared.inc'
      real*4 rnd(1)
      common/getiswfirstoriginal/ifirst
      data ifirst /1/
      if (ifirst.eq.1) then
         ifirst = 0
      endif
      sumpdfpdf = 0.d0
      psum      = 0.d0
      weight    = 0.d0
      do j = 1,ifl,2
         do i = 2, ifl,2
            if (chfs.lt.0.d0) then
               i1 = j
               i2 = -i
            else
               i1 = -j
               i2 = i
            endif
            Vud2 = myckm(i1,i2)**2
            if (i_pdf.eq.0) Vud2 = 1.d0

            if (pdf1(i1).lt.0.d0) pdf1(i1) = 0.d0
            if (pdf2(i2).lt.0.d0) pdf2(i2) = 0.d0
            if (pdf1(i2).lt.0.d0) pdf1(i2) = 0.d0
            if (pdf2(i1).lt.0.d0) pdf2(i1) = 0.d0

            pdfpdf(-i1,-i2) = 0.d0
            pdfpdf(-i2,-i1) = 0.d0

            pdfpdf(i1,i2) = pdf1(i1)*pdf2(i2) * Vud2
            pdfpdf(i2,i1) = pdf1(i2)*pdf2(i1) * Vud2
            sumpdfpdf = sumpdfpdf + pdfpdf(i1,i2) + pdfpdf(i2,i1)            
         enddo
      enddo 
* It can happen that the pdf product for a given x1, x2 is zero for all
* the particles. In this case, no process can occur: I keep ipart1 
* and ipart2 = ifl+1 and the routine exits
      if (sumpdfpdf.eq.0.d0) then        
         ipart1 = ifl + 1
         ipart2 = ifl + 1
         return
      endif
      weight = sumpdfpdf
* choose the process...
      i_stop = 0     
      j= -ifl - 1
      call wraprng(rnd,1)
      do while(i_stop.eq.0.and.j.lt.ifl)
         j =  j + 1         
         i = -ifl-1
         do while(i_stop.eq.0.and.i.lt.ifl)
               i = i + 1
               if (i.ne.j.and.i.ne.0.and.j.ne.0) then
               psum   = psum + pdfpdf(i,j)
               psum_n = psum/sumpdfpdf               
               if (psum_n.gt.rnd(1)) then
                  m1  = mq(i)
                  m2  = mq(j)
                  ch1 = chq(i)
                  ch2 = chq(j)
                  ipart1 = i
                  ipart2 = j               
                  i_stop = 1
               endif
            endif
         enddo
      enddo
      return
      end
********************************************
      subroutine get_is_Z(x1,x2,s,weight)
      include 'shared.inc'
      real*4 rnd(1)
      sumpdfpdf = 0.d0
      psum      = 0.d0
      weight    = 0.d0
      do j = -ifl, ifl
         i = -j
*     no FCNC !!!!!!!!!!!!!!!	 
         pdf1i = pdf1(i) 
         pdf2j = pdf2(j)
         if (pdf1i.lt.0.d0) pdf1i = 0.d0
         if (pdf2j.lt.0.d0) pdf2j = 0.d0
         pdfpdf(i,j) = pdf1i*pdf2j
         sumpdfpdf = sumpdfpdf + pdfpdf(i,j)            
      enddo 
* It can happen that the pdf product for a given x1, x2 is zero for all
* the particles. In this case, no process can occur: I keep ipart1 
* and ipart2 = ifl+1 and the routine exits
      if (sumpdfpdf.eq.0.d0) then        
         ipart1 = ifl+1
         ipart2 = ifl+1
         return
      endif
      weight = sumpdfpdf
* choose the process...
      i_stop = 0
      j=-ifl-1
      call wraprng(rnd,1)
      do while(i_stop.eq.0.and.j.lt.ifl)
         j =  j + 1
         i = -j
         psum   = psum + pdfpdf(i,j)
         psum_n = psum/sumpdfpdf

         if (psum_n.gt.rnd(1)) then ! i,j correspond to 
                                ! the occurring
                                ! process,  when 
                                ! the do-loop stops
            m1  = mq(i)
            m2  = mq(j)
            ch1 = chq(i)
            ch2 = chq(j)               
            ipart1 = i
            ipart2 = j               
            i_stop = 1
         endif
      enddo
      return
      end
***********************************************************
      subroutine get_pdf(x1,x2,s)
      include 'shared.inc'
      parameter (iiiii=2*ifl+1)
      data pdf1 /iiiii*0.d0/
      data pdf2 /iiiii*0.d0/
      real*4 csi(1)
* The initial state is selected. For example, the process initiated by
* u d_bar is kept distinguished from the d_bar u, since in the proton and
* anti-proton the PDF quark content is different....
      if (i_pdf.ne.0) then   ! if the PDF cross section is selected....
* PDF called for hadron 1
         call pdf_wrapper(x1,s,up,down,aup,adown,str,ch,bot,glu,photon)
         if (hadr1.eq.2212) then  ! if the hadron is a proton....
            pdf1(1)  = down
            pdf1(2)  = up
            pdf1(3)  = str
            pdf1(4)  = ch
            pdf1(5)  = bot
            pdf1(-1) = adown
            pdf1(-2) = aup
            pdf1(-3) = str
            pdf1(-4) = ch
            pdf1(-5) = bot

            pdf1(0)  = photon
         else ! else, if it is an antiproton....
            pdf1(-1) = down
            pdf1(-2) = up
            pdf1(-3) = str
            pdf1(-4) = ch
            pdf1(-5) = bot
            pdf1(1)  = adown
            pdf1(2)  = aup
            pdf1(3)  = str
            pdf1(4)  = ch
            pdf1(5)  = bot

            pdf1(0)  = photon
         endif
c         do i= -ifl, ifl ! checked after!!
c            if (pdf1(i).lt.0.d0) pdf1(i)=0.d0
c         enddo    
* PDF called for hadron 2
         call pdf_wrapper(x2,s,up,down,aup,adown,str,ch,bot,glu,photon)
         if (hadr2.eq.2212) then ! if the hadron is a proton....
            pdf2(1)  = down
            pdf2(2)  = up
            pdf2(3)  = str
            pdf2(4)  = ch
            pdf2(5)  = bot
            pdf2(-1) = adown
            pdf2(-2) = aup
            pdf2(-3) = str
            pdf2(-4) = ch
            pdf2(-5) = bot

            pdf2(0)  = photon
         else                   ! else, if it is an antiproton....
            pdf2(-1) = down
            pdf2(-2) = up
            pdf2(-3) = str
            pdf2(-4) = ch
            pdf2(-5) = bot
            pdf2(1)  = adown
            pdf2(2)  = aup
            pdf2(3)  = str
            pdf2(4)  = ch
            pdf2(5)  = bot

            pdf2(0)  = photon
         endif
c         do i = -ifl, ifl ! checked after!!
c            if (pdf2(i).lt.0.d0) pdf2(i)=0.d0
c         enddo    
      else  ! if the partonic cross section is selected....
         pdf1(iquark1)  = 1.d0
         pdf2(iquark2)  = 1.d0
c$$$         pdf1( 1) = 1.d0
c$$$         pdf1(-1) = 0.d0
c$$$         pdf1( 2) = 1.d0
c$$$         pdf1(-2) = 0.d0
c$$$         pdf2( 1) = 0.d0
c$$$         pdf2(-1) = 1.d0
c$$$         pdf2( 2) = 0.d0
c$$$         pdf2(-2) = 1.d0
      endif
      return
      end

