      subroutine phasespace(p1,p2,p3,p4,qph,nphot,m1,m2,esoft,
     .     w,phsp,ie)
      implicit double precision (a-h,m,o-z)
      dimension p1(0:3),p2(0:3),p3(0:3),p4(0:3),q(0:3)
      dimension dir3(0:3),dir4(0:3),ptmp(0:3),vers(0:3)
      double precision kone(0:3),k1(0:3),k2(0:3),pp(0:3)
      double precision lambda
      double precision mq(-5:5),chq(-5:5),itre(-5:5)
      character*1 boson
      integer emissionpattern(nphot)
      parameter (pi = 3.1415926535897932384626433832795029d0)
      parameter (imaxph = 40)
      double precision qph(imaxph,0:3),oph(imaxph)
      common/cosgp3/cgp3
      common/nrandom/ir
      real*4 rnd(2),csi(1)
      common/radpattern/nph(4)      
      common/masseinitial/muno,mdue
      common/partialweights/wlepang,wphoten,wphotang,reg
! from shared.inc      
      common/vectorboson/boson
      common/masseshor/me,mmu,mw,mz,mu,md,mc,ms,mtau,mb,mt,
     .     mq,chq,itre
      common/t_widths/gw,gz
      npart = nphot + 2
      nvar  = 3*nphot + 2

      ncharged = 4
      if (boson.eq.'W') ncharged = 3
      ie     = 0
      w      = 1.d0
      wlepang = 1.d0
      wphoten = 1.d0
      wphotang = 1.d0
      reg      = 1.d0
      phsp   = 1.d0
      duepigrechi = (2.d0*pi)**(-nvar)
      iwider = 0
      ntot   = nphot
      egmin  = esoft
      do j = 0,3
         do k = 1,imaxph
            qph(k,j) = 0.d0
         enddo
      enddo

      eb     = p1(0)
      ebper2 = 2.d0*eb
      if (ebper2.lt.(m1+m2+nphot*esoft)) then 
         phsp = 0.d0
         w    = 0.d0
         ie = 1
         return
      endif
*****************
      ir = 1
      call wraprng(rnd,2)
      if (nphot.eq.0) then
         mass = p1(0)+p2(0)
         sqla = sqrt(lambda(mass**2,m1**2,m2**2))
         phsp = phsp * sqla/8.d0/mass**2
         call get_cos_fer(rnd(1),nphot,c,wcos)
         w = w * wcos
         s = sqrt(1.d0 - c**2)
         call get_phi(rnd(2),phi,wph)
         w = w*wph
         wlepang = wcos*wph
         sphi = sin(phi)
         cphi = cos(phi)
         p1mod = sqla/2.d0/mass
         p3(0) = sqrt(p1mod**2 + m1**2)
         p3(1) = p1mod * sphi * s
         p3(2) = p1mod * cphi * s
         p3(3) = p1mod * c
         p4(0) = mass - p3(0)
         p4(1) = - p3(1)
         p4(2) = - p3(2)
         p4(3) = - p3(3)
         phsp = phsp * duepigrechi
         return
      endif
*******************
******************
* the following for ng >= 1
      pflatc = 0.d0 ! for collinear sampling, flat fraction
      call get_cos_fer(rnd(ir),nphot,cth,wcos)
      w = w * wcos
      sth = sqrt(1.d0 - cth**2)
      call get_phi(rnd(ir+1),phi,wph)
      w = w*wph
      wlepang = wcos*wph
      sphi = sin(phi)
      cphi = cos(phi)
      ir = ir + 2
      do k = 1,4
         nph(k) = 0
      enddo
      wpattern = 1.d0
      call get_pattern(ncharged,nphot,emissionpattern)
c      call get_pattern_v2(ncharged,nphot,emissionpattern,wpattern)
      w = w*wpattern
      do k = 1,nphot
         nph(emissionpattern(k)) = nph(emissionpattern(k)) + 1
      enddo
      n1 = nph(1)
      n2 = nph(2)
      n3 = nph(3)
      n4 = nph(4)

      ei = p1(0)+p2(0)
      beta = sqrt(1.d0 - m1**2/p1(0)**2)

      dir3(0) = p1(0)
      dir3(1) = p1(0)*beta*cphi*sth
      dir3(2) = p1(0)*beta*sphi*sth
      dir3(3) = p1(0)*beta*cth         
      dir4(0) = dir3(0)
      pp(0)   = p1(0)+p2(0)
      do k = 1,3
         pp(k) = p1(k)+p2(k)
         dir4(k) = -dir3(k)
      enddo               
** PHOTONS GENERATION...
      nis = n1 + n2
      nfs = n3 + n4
** initial state photons - 1
      isharebw = 0
      if (n1.ge.1) isharebw = isharebw + 1 
      if (n2.ge.1) isharebw = isharebw + 1 
      if (n3.ge.1) isharebw = isharebw + 1 
      if (n4.ge.1) isharebw = isharebw + 1 

      if (boson.eq.'W') then
         amv = mw
         agv = gw
      else
         amv = mz
         agv = gz
      endif

      if (nis.gt.0) then
         if (n1.gt.0) then
            do k = 1,max(n1,1)
               pflat1 = pflatc
c               pflat1 = 0.1d0
               c1 = 2.d0/3.d0
               c2 = 1.d0/3.d0
               call wraprng(rnd,2)
               call collinearm2(c1,c2,muno,pflat1,rnd(1),rnd(2),
     .              p1,vers,wverg)
               cgp3 = tridot(vers,dir3)/beta/dir3(0)
               ir = ir + 2
               w = w * wverg
               wphotang = wphotang * wverg

               pbwbase = 0.2d0/isharebw
               if (pp(0).gt.90.d0)  pbwbase = 0.7d0/isharebw
               if (pp(0).gt.120.d0) pbwbase = 0.8d0/isharebw
               pbw = pbwbase

               q2min = (m1+m2)**2
               call wraprng(csi,1)
               call photon_energy(pbw,csi(1),pp,vers,q2min,esoft,
     .              p1(0),amv,agv,om,wom)
               oph(k) = om
               ir = ir + 1
               w = w * wom
               wphoten = wphoten * wom

               qph(k,0) = oph(k)
               qph(k,1) = oph(k)*vers(1)
               qph(k,2) = oph(k)*vers(2)
               qph(k,3) = oph(k)*vers(3)

               pp(0)    = pp(0) - qph(k,0)
               pp(1)    = pp(1) - qph(k,1)
               pp(2)    = pp(2) - qph(k,2)
               pp(3)    = pp(3) - qph(k,3)
            enddo
         endif
         if (n2.gt.0) then
            do k = 1,max(n2,1)
               pflat2 = pflatc
c               pflat2 = 0.1d0
               c1 = 1.d0/3.d0
               c2 = 2.d0/3.d0
               call wraprng(rnd,2)
               call collinearm2(c1,c2,mdue,pflat2,rnd(1),rnd(2),p2,
     .              vers,wverg)
               cgp3 = tridot(vers,dir3)/beta/dir3(0)

               ir = ir + 2
               w = w * wverg
               wphotang = wphotang * wverg

               pbwbase = 0.2d0/isharebw
               if (pp(0).gt.90.d0)  pbwbase = 0.7d0/isharebw
               if (pp(0).gt.120.d0) pbwbase = 0.8d0/isharebw
               pbw = pbwbase

               q2min = (m1+m2)**2
               call wraprng(csi,1)
               call photon_energy(pbw,csi(1),pp,vers,q2min,esoft,
     .              p1(0),amv,agv,om,wom)
               oph(k+n1) = om
               ir = ir + 1
               w = w * wom
               wphoten = wphoten * wom

               qph(k+n1,0) = oph(k+n1)
               qph(k+n1,1) = oph(k+n1)*vers(1)
               qph(k+n1,2) = oph(k+n1)*vers(2)
               qph(k+n1,3) = oph(k+n1)*vers(3)

               pp(0)    = pp(0) - qph(k+n1,0)
               pp(1)    = pp(1) - qph(k+n1,1)
               pp(2)    = pp(2) - qph(k+n1,2)
               pp(3)    = pp(3) - qph(k+n1,3)
            enddo
         endif
      endif
** final state photons
      if (nfs.gt.0) then
         if (n3.gt.0) then
            do k = 1,max(n3,1)
               c1 = 1.d0
               c2 = 1.d0
               call wraprng(rnd,2)
               call collinearm2(c1,c2,m1,pflatc,rnd(1),rnd(2),dir3,
     .              vers,wverg)
c               pflatt = 0.05d0
c               call collinear(pflatt,rnd(1),rnd(2),dir3,vers,wverg)
               cgp3 = tridot(vers,dir3)/beta/dir3(0)

               ir = ir + 2
               w = w * wverg
               wphotang = wphotang * wverg

               pbwbase = 0.2d0/isharebw
               if (pp(0).gt.90.d0)  pbwbase = 0.7d0/isharebw
               if (pp(0).gt.120.d0) pbwbase = 0.8d0/isharebw
               pbw = pbwbase

               q2min = (m1+m2)**2
               call wraprng(csi,1)
               call photon_energy(pbw,csi(1),pp,vers,q2min,esoft,
     .              p1(0),amv,agv,om,wom)
               oph(k+n1+n2) = om
               ir = ir + 1
               w = w * wom
               wphoten = wphoten * wom

               qph(k+n1+n2,0) = oph(k+n1+n2)
               qph(k+n1+n2,1) = oph(k+n1+n2)*vers(1)
               qph(k+n1+n2,2) = oph(k+n1+n2)*vers(2)
               qph(k+n1+n2,3) = oph(k+n1+n2)*vers(3)

               pp(0)    = pp(0) - qph(k+n1+n2,0)
               pp(1)    = pp(1) - qph(k+n1+n2,1)
               pp(2)    = pp(2) - qph(k+n1+n2,2)
               pp(3)    = pp(3) - qph(k+n1+n2,3)
            enddo
         endif
         if (n4.gt.0) then
            do k = 1,max(n4,1)
               c1 = 1.d0
               c2 = 1.d0
               call wraprng(rnd,2)
               call collinearm2(c1,c2,m2,pflatc,rnd(1),rnd(2),dir4,
     .              vers,wverg)
               cgp3 = tridot(vers,dir3)/beta/dir3(0)

               ir = ir + 2
               w = w * wverg
               wphotang = wphotang * wverg

               pbwbase = 0.2d0/isharebw
               if (pp(0).gt.90.d0)  pbwbase = 0.7d0/isharebw
               if (pp(0).gt.120.d0) pbwbase = 0.8d0/isharebw
               pbw = pbwbase

               q2min = (m1+m2)**2
               call wraprng(csi,1)
               call photon_energy(pbw,csi(1),pp,vers,q2min,esoft,
     .              p1(0),amv,agv,om,wom)
               oph(k+n1+n2+n3) = om
               ir = ir + 1
               w = w * wom
               wphoten = wphoten * wom

               qph(k+n1+n2+n3,0) = oph(k+n1+n2+n3)
               qph(k+n1+n2+n3,1) = oph(k+n1+n2+n3)*vers(1)
               qph(k+n1+n2+n3,2) = oph(k+n1+n2+n3)*vers(2)
               qph(k+n1+n2+n3,3) = oph(k+n1+n2+n3)*vers(3)

               pp(0)    = pp(0) - qph(k+n1+n2+n3,0)
               pp(1)    = pp(1) - qph(k+n1+n2+n3,1)
               pp(2)    = pp(2) - qph(k+n1+n2+n3,2)
               pp(3)    = pp(3) - qph(k+n1+n2+n3,3)
            enddo
         endif
      endif
***********************************
      do k = 0,3
         kone(k) = 0.d0
      enddo
      do j = 0,3
         do k = 1,nphot
            kone(j) = kone(j) + qph(k,j)
         enddo
         ptmp(j) = p1(j) + p2(j) - kone(j)
      enddo
      if (dot(ptmp,ptmp).lt.(m1+m2)**2.or.ptmp(0).lt.0.d0) then
         ie = 1
         phsp = 0.d0
         w  = 0.d0
         return
      endif
      amkone2 = dot(kone,kone)
***
      call wraprng(csi,1)
      ich = nphot * csi(1) + 1
      ich = min(ich,nphot) ! to avoid round-offs
      iref = 3
      if (ich.gt.(n1+n2+n3)) iref = 4
***         
      if (iref.eq.3) then
         vx  = sth*cphi
         vy  = sth*sphi
         vz  = cth
      else
         vx  = -sth*cphi
         vy  = -sth*sphi
         vz  = -cth
      endif

      o   = kone(0)
      ox  = kone(1)
      oy  = kone(2)
      oz  = kone(3)
      odv = ox*vx + oy*vy + oz*vz

      abig = ei**2 - 2.d0 * ei * o + amkone2 + m1**2 - m2**2
      bbig = -2.d0 * (ei - o)
      cbig = -2.d0 * odv
      arg  = abig**2*bbig**2-m1**2*bbig**2*(bbig**2-cbig**2)
      if (arg.lt.0.d0) then
         phsp = 0.d0
         w    = 0.d0
         ie = 2
         return
      endif
      p1mod_1 = abig*cbig + sqrt(arg)
      p1mod_1 = p1mod_1 / (bbig**2 - cbig**2)
      p1mod_2 = abig*cbig - sqrt(arg)
      p1mod_2 = p1mod_2 / (bbig**2 - cbig**2)
      p1jac = 1.d0
      if (p1mod_1.gt.0.d0.and.p1mod_2.gt.0.d0) then
         call wraprng(csi,1)
         if (csi(1).lt.0.5) p1mod = p1mod_1
         if (csi(1).ge.0.5) p1mod = p1mod_2
         p1jac = 2.d0
      endif
      if (p1mod_1.gt.0.d0.and.p1mod_2.lt.0.d0) then
         p1mod = p1mod_1
      endif
      if (p1mod_1.lt.0.d0.and.p1mod_2.gt.0.d0) then
         p1mod = p1mod_2
      endif
      if (p1mod_1.lt.0.d0.and.p1mod_2.lt.0.d0) then
         phsp = 0.d0
         w    = 0.d0
         ie   = 3
         return
      endif

      w       = w * p1jac
      wphoten = wphoten * p1jac

      p3(0) = sqrt(p1mod**2 + m1**2)
      p3(1) = p1mod*vx
      p3(2) = p1mod*vy
      p3(3) = p1mod*vz      
      p4(0) =  ei - p3(0) - o
      p4(1) = -ox - p3(1)
      p4(2) = -oy - p3(2)
      p4(3) = -oz - p3(3)

!      phasespace!
      prodomega = 1.d0
      do k = 1,nphot
         prodomega = prodomega * qph(k,0)
      enddo
      den = dabs( p4(0) + p3(0)*(1.d0 + odv/p1mod) )
      phsp = prodomega * p1mod / den
      phsp = phsp*duepigrechi/2.d0**(npart)
      if (iref.eq.4) call exchange_mom(p3,p4)
***********************      
! regolatore
!!! only on the final state -- as in BabaYaga... 
      den = 0.d0
      if (n3.gt.0.and.n4.gt.0) then
         prodp3 = 1.d0
         prodp4 = 1.d0
         do k = nis+1,nphot
            do i = 0,3
               ptmp(i) = qph(k,i)
            enddo
            p3q = dot(p3,ptmp)
            p4q = dot(p4,ptmp)
            if (k.le.(n1+n2+n3)) then
               prodp3=prodp3*
     .              (1.d0/p3q*p3(0)*ptmp(0))
            endif
            if (k.gt.(n1+n2+n3)) then
               prodp4=prodp4*
     .              (1.d0/p4q*p4(0)*ptmp(0))
            endif
         enddo
         if (iref.eq.3) anum = prodp3
         if (iref.eq.4) anum = prodp4
         regulator1 = anum/(prodp3+prodp4) * 2.d0
         w = w * regulator1
         reg = reg * regulator1
      endif
*******************
* secondo regolatore
      ifour = 1
      if (boson.eq.'W') ifour = 0
c      clog1 = log( (p1(0)+sqrt(tridot(p1,p1))) /
c     .     (p1(0)-sqrt(tridot(p1,p1))) )
c      clog2 = log( (p2(0)+sqrt(tridot(p2,p2))) /
c     .     (p2(0)-sqrt(tridot(p2,p2))) )
c      clog3 = log( (p3(0)+sqrt(tridot(p3,p3))) /
c     .     (p3(0)-sqrt(tridot(p3,p3))) )
      clog1 = 1.d0 !/ (4.d0/9.d0)
      clog2 = 1.d0 !/ (1.d0/9.d0)
      clog3 = 1.d0
      clog4 = 1.d0
c$$$      if (boson.ne.'W')
c$$$     .     clog4 = log( (p4(0)+sqrt(tridot(p4,p4))) /
c$$$     .     (p4(0)-sqrt(tridot(p4,p4))) )
      den  = 1.d0
      anum = 1.d0
      if (n1.gt.0) then
         do k = 1,max(n1,1)
            do i = 0,3
               ptmp(i) = qph(k,i)
            enddo            
            den = den * (
     .           1.d0/dot(p1,ptmp)*p1(0)*ptmp(0)/clog1 +
     .           1.d0/dot(p2,ptmp)*p2(0)*ptmp(0)/clog2 +
     .           1.d0/dot(p3,ptmp)*p3(0)*ptmp(0)/clog3 +
     .     ifour*1.d0/dot(p4,ptmp)*p4(0)*ptmp(0)/clog4 )
            anum = anum/dot(p1,ptmp)*p1(0)*ptmp(0)/clog1
         enddo
      endif
      if (n2.gt.0) then
         do k = n1+1,n1+n2
            do i = 0,3
               ptmp(i) = qph(k,i)
            enddo
            den = den * (
     .           1.d0/dot(p1,ptmp)*p1(0)*ptmp(0)/clog1 +
     .           1.d0/dot(p2,ptmp)*p2(0)*ptmp(0)/clog2 +
     .           1.d0/dot(p3,ptmp)*p3(0)*ptmp(0)/clog3 +
     .     ifour*1.d0/dot(p4,ptmp)*p4(0)*ptmp(0)/clog4 )
            anum = anum/dot(p2,ptmp)*p2(0)*ptmp(0)/clog2
         enddo
      endif
      if (n3.gt.0) then
         do k = n1+n2+1,n1+n2+n3
            do i = 0,3
               ptmp(i) = qph(k,i)
            enddo
            den = den * (
     .           1.d0/dot(p1,ptmp)*p1(0)*ptmp(0)/clog1 +
     .           1.d0/dot(p2,ptmp)*p2(0)*ptmp(0)/clog2 +
     .           1.d0/dot(p3,ptmp)*p3(0)*ptmp(0)/clog3 +
     .     ifour*1.d0/dot(p4,ptmp)*p4(0)*ptmp(0)/clog4 )
            anum = anum/dot(p3,ptmp)*p3(0)*ptmp(0)/clog3
         enddo
      endif
      if (n4.gt.0) then
         do k = n1+n2+n3+1,nphot
            do i = 0,3
               ptmp(i) = qph(k,i)
            enddo
            den = den * (
     .           1.d0/dot(p1,ptmp)*p1(0)*ptmp(0)/clog1 +
     .           1.d0/dot(p2,ptmp)*p2(0)*ptmp(0)/clog2 +
     .           1.d0/dot(p3,ptmp)*p3(0)*ptmp(0)/clog3 +
     .     ifour*1.d0/dot(p4,ptmp)*p4(0)*ptmp(0)/clog4 )
            anum = anum/dot(p4,ptmp)*p4(0)*ptmp(0)/clog4
         enddo
      endif
      regulator2 = 1.d0* ncharged**(nphot) * anum/den
!!! ATTENZIONE CON get_pattern usare la linea precedente!!!
! con get_pattern_v2 quella successiva!!
cc      regulator2 = 1.d0 * anum/den
c$$$      test = regulator2/3.d0
c$$$      if (test.lt.0.05d0) then 
c$$$         print*,'---'
c$$$         print*,test
c$$$         sum = 1.d0/dot(p1,ptmp)*p1(0)*ptmp(0)
c$$$         sum = sum + 1.d0/dot(p2,ptmp)*p2(0)*ptmp(0)
c$$$         sum = sum + 1.d0/dot(p3,ptmp)*p3(0)*ptmp(0)
c$$$         sum = sum + 1.d0/dot(p4,ptmp)*p4(0)*ptmp(0)
c$$$         print*,1.d0/dot(p1,ptmp)*p1(0)*ptmp(0)/sum
c$$$         print*,1.d0/dot(p2,ptmp)*p2(0)*ptmp(0)/sum
c$$$         print*,1.d0/dot(p3,ptmp)*p3(0)*ptmp(0)/sum
c$$$         print*,1.d0/dot(p4,ptmp)*p4(0)*ptmp(0)/sum
c$$$      endif
      w   = w * regulator2
      reg = reg * regulator2
***********************
      return
      end
