set terminal epslatex color dashed



###

set ytics autofreq
set autoscale
unset xlabel
unset ylabel
unset logscale
unset log y

set yrange [0.99:1.01]


set output "plot.tex"

set xlabel '$M_\perp^W$ (GeV)'
set ylabel 'R'
set label '$p \bar p \to \mu^+\nu_\mu +X$' at 63,0.995
set label 'Tevatron' at 63,0.993
set label 'R=$\sigma(\kappa)/\sigma(\kappa=1)$' at 63,0.991
set label 'lower plots $\kappa=2$, upper plots $\kappa=0.5$' at 63,1.007

plot "< paste test-mu-PS/tev_w_mu_mtv1_best_norec_100.dat\
              test-mu-2/tev_w_mu_mtv1_best_norec_100.dat\
              test-mu-05/tev_w_mu_mtv1_best_norec_100.dat"\
     u 1:($5/$2) w his lt 1 lw 3 title 'exp',\
     "< paste test-mu-PS/tev_w_mu_mtv1_best_norec_100.dat\
              test-mu-2/tev_w_mu_mtv1_best_norec_100.dat\
              test-mu-05/tev_w_mu_mtv1_best_norec_100.dat"\
     u 1:($8/$2) w his lt 1 lw 3 notitle '',\
 "< paste test-oal-mu-PS/tev_w_mu_mtv1_oal_norec_100.dat\
              test-oal-mu-2/tev_w_mu_mtv1_oal_norec_100.dat\
              test-oal-mu-05/tev_w_mu_mtv1_oal_norec_100.dat"\
     u 1:($5/$2) w his lt 2 lw 3 title '${\cal O}(\alpha)$',\
     "< paste test-oal-mu-PS/tev_w_mu_mtv1_oal_norec_100.dat\
              test-oal-mu-2/tev_w_mu_mtv1_oal_norec_100.dat\
              test-oal-mu-05/tev_w_mu_mtv1_oal_norec_100.dat"\
     u 1:($8/$2) w his lt 2 lw 3 notitle ''

unset output
system "latex wrapper2.tex && dvips wrapper2.dvi -o && ps2epsi wrapper2.ps nll-mu-tev-scalePS.eps"
system "epstopdf nll-mu-tev-scalePS.eps"
set autoscale
unset label




###

set ytics autofreq
set autoscale
unset xlabel
unset ylabel
unset logscale
unset log y

set yrange [0.99:1.01]


set output "plot.tex"

set xlabel '$M_\perp^W$ (GeV)'
set ylabel 'R'
set label '$p \bar p \to e^+\nu_e +X$' at 63,0.995
set label 'Tevatron' at 63,0.993
set label 'R=$\sigma(\kappa)/\sigma(\kappa=1)$' at 63,0.991
set label 'lower plots $\kappa=2$, upper plots $\kappa=0.5$' at 63,1.007

plot "< paste test-el-PS/tev_w_el_mtv1_best_norec_100.dat\
              test-el-2/tev_w_el_mtv1_best_norec_100.dat\
              test-el-05/tev_w_el_mtv1_best_norec_100.dat"\
     u 1:($5/$2) w his lt 1 lw 3 title 'exp',\
     "< paste test-el-PS/tev_w_el_mtv1_best_norec_100.dat\
              test-el-2/tev_w_el_mtv1_best_norec_100.dat\
              test-el-05/tev_w_el_mtv1_best_norec_100.dat"\
     u 1:($8/$2) w his lt 1 lw 3 notitle '',\
 "< paste test-oal-el-PS/tev_w_el_mtv1_oal_norec_100.dat\
              test-oal-el-2/tev_w_el_mtv1_oal_norec_100.dat\
              test-oal-el-05/tev_w_el_mtv1_oal_norec_100.dat"\
     u 1:($5/$2) w his lt 2 lw 3 title '${\cal O}(\alpha)$',\
     "< paste test-oal-el-PS/tev_w_el_mtv1_oal_norec_100.dat\
              test-oal-el-2/tev_w_el_mtv1_oal_norec_100.dat\
              test-oal-el-05/tev_w_el_mtv1_oal_norec_100.dat"\
     u 1:($8/$2) w his lt 2 lw 3 notitle ''

unset output
system "latex wrapper2.tex && dvips wrapper2.dvi -o && ps2epsi wrapper2.ps nll-el-tev-scalePS.eps"
system "epstopdf nll-el-tev-scalePS.eps"
set autoscale
unset label


###

set ytics autofreq
set autoscale
unset xlabel
unset ylabel
unset logscale
unset log y

set yrange [0.997:1.001]


set output "plot.tex"

set xlabel '$M_\perp^W$ (GeV)'
set ylabel 'R=(with extra pairs)/(without)'
set label '$p \bar p \to \mu^+\nu_\mu +X$' at 63,0.999
set label 'Tevatron' at 63,0.9985
set label 'FSR QED-PS exp' at 63,0.998
plot "< paste test-mu-PS/tev_w_mu_mtv1_best_norec_100.dat\
              test-mu-ee/tev_w_mu_mtv1_best_norec_100.dat\
              test-mu-ee+mm/tev_w_mu_mtv1_best_norec_100.dat"\
     u 1:($5/$2) w his lt 1 lw 3 title 'additional $e^+e^-$',\
     "< paste test-mu-PS/tev_w_mu_mtv1_best_norec_100.dat\
              test-mu-ee/tev_w_mu_mtv1_best_norec_100.dat\
              test-mu-ee+mm/tev_w_mu_mtv1_best_norec_100.dat"\
     u 1:($8/$2) w his lt 2 lw 3 title 'additional $e^+e^-$ and $\mu^+\mu^-$'


unset output
system "latex wrapper2.tex && dvips wrapper2.dvi -o && ps2epsi wrapper2.ps pairs-mu-tev.eps"
system "epstopdf pairs-mu-tev.eps"
set autoscale
unset label



###

set ytics autofreq
set autoscale
unset xlabel
unset ylabel
unset logscale
unset log y

set yrange [0.997:1.001]


set output "plot.tex"

set xlabel '$M_\perp^W$ (GeV)'
set ylabel 'R=(with extra pairs)/(without)'
set label '$p \bar p \to e^+\nu_e +X$' at 63,0.999
set label 'Tevatron' at 63,0.9985
set label 'FSR QED-PS exp' at 63,0.998
plot "< paste test-el-PS/tev_w_el_mtv1_best_norec_100.dat\
              test-el-ee/tev_w_el_mtv1_best_norec_100.dat\
              test-el-ee+mm/tev_w_el_mtv1_best_norec_100.dat"\
     u 1:($5/$2) w his lt 1 lw 3 title 'additional $e^+e^-$',\
     "< paste test-el-PS/tev_w_el_mtv1_best_norec_100.dat\
              test-el-ee/tev_w_el_mtv1_best_norec_100.dat\
              test-el-ee+mm/tev_w_el_mtv1_best_norec_100.dat"\
     u 1:($8/$2) w his lt 2 lw 3 title 'additional $e^+e^-$ and $\mu^+\mu^-$'


unset output
system "latex wrapper2.tex && dvips wrapper2.dvi -o && ps2epsi wrapper2.ps pairs-el-tev.eps"
system "epstopdf pairs-el-tev.eps"
set autoscale
unset label

