set terminal epslatex color dashed

set ytics autofreq
set autoscale
unset xlabel
unset ylabel
unset logscale
unset log y

set yrange [0.995:1.01]

set output "plot.tex"

set key top left

set xlabel '$M_\perp^W$ (GeV)'
set ylabel 'R'
set label 'p pbar $\to e^+\nu_e +X$' at 63,0.999
set label '$R=\frac{PS(\kappa)}{{\cal O}(\alpha)}$' at 63,0.997
plot "< paste test-new-oal-el-1/tev_w_el_mtv1_oal_norec_100.dat\
              test-carlo-oal-el-075/tev_w_el_mtv1_oal_norec_100.dat\
              test-carlo-oal-el-105/tev_w_el_mtv1_oal_norec_100.dat\
              test-carlo-oal-el-135/tev_w_el_mtv1_oal_norec_100.dat"\
     u 1:($5/$2/361.72*360.72) smooth bezier lt 1 lw 3 title '$\kappa=0.75$',\
 "< paste test-new-oal-el-1/tev_w_el_mtv1_oal_norec_100.dat\
              test-carlo-oal-el-075/tev_w_el_mtv1_oal_norec_100.dat\
              test-carlo-oal-el-085/tev_w_el_mtv1_oal_norec_100.dat\
              test-carlo-oal-el-135/tev_w_el_mtv1_oal_norec_100.dat"\
     u 1:($8/$2/361.42*360.72) smooth bezier lt 2 lw 3 title '$\kappa=0.85$',\
 "< paste test-new-oal-el-1/tev_w_el_mtv1_oal_norec_100.dat\
              test-carlo-oal-el-075/tev_w_el_mtv1_oal_norec_100.dat\
              test-carlo-oal-el-100/tev_w_el_mtv1_oal_norec_100.dat\
              test-carlo-oal-el-135/tev_w_el_mtv1_oal_norec_100.dat"\
     u 1:($8/$2/361.42*360.72) smooth bezier lt 3 lw 3 title '$\kappa=1.00$',\
 "< paste test-new-oal-el-1/tev_w_el_mtv1_oal_norec_100.dat\
              test-carlo-oal-el-075/tev_w_el_mtv1_oal_norec_100.dat\
              test-carlo-oal-el-105/tev_w_el_mtv1_oal_norec_100.dat\
              test-carlo-oal-el-135/tev_w_el_mtv1_oal_norec_100.dat"\
     u 1:($11/$2/361.20*360.72) smooth bezier lt 4 lw 3 title '$\kappa=1.35$',\
 1.00 w his lt 5 lw 3

unset output
system "latex wrapper2.tex && dvips wrapper2.dvi -o && ps2epsi wrapper2.ps scale-search.eps"
system "epstopdf scale-search.eps"
set autoscale
unset label



set ytics autofreq
set autoscale
unset xlabel
unset ylabel
unset logscale
unset log y

set yrange [0.9984:1.0004]

set output "plot.tex"

set xlabel '$M_\perp^W$ (GeV)'
set ylabel 'R'
set label 'p pbar $\to \mu^+\nu_\mu +X$' at 63,0.999

plot "< paste coppie-PS-mu/tev_w_mu_mtv1_best_norec_100.dat\
              coppie-full-mu/tev_w_mu_mtv1_best_norec_100.dat\
              coppie-DSbeta0-mu/tev_w_mu_mtv1_best_norec_100.dat\
              coppie-noDS-mu/tev_w_mu_mtv1_best_norec_100.dat"\
     u 1:($5/$2) w his lt 1 lw 3 title 'full',\
     "< paste coppie-PS-mu/tev_w_mu_mtv1_best_norec_100.dat\
              coppie-full-mu/tev_w_mu_mtv1_best_norec_100.dat\
              coppie-DSbeta0-mu/tev_w_mu_mtv1_best_norec_100.dat\
              coppie-noDS-mu/tev_w_mu_mtv1_best_norec_100.dat"\
     u 1:($11/$2) w his lt 3 lw 3 title 'only beta(s), no singlet'

unset output
system "latex wrapper2.tex && dvips wrapper2.dvi -o && ps2epsi wrapper2.ps pairs-mu.eps
system "epstopdf pairs-mu.eps"
set autoscale
unset label







