      subroutine shiftcomponent(p03,p14,i)
      ! i = '<-' or '->'
      character*2 i
      double precision p03(0:3),p14(4)
      if (i.eq.'->') then
         p14(4) = p03(0)
         p14(1) = p03(1)
         p14(2) = p03(2)
         p14(3) = p03(3)
      else
         p03(0) = p14(4)
         p03(1) = p14(1)
         p03(2) = p14(2)
         p03(3) = p14(3)
      endif
      return
      end
c
c********************* atlsmear **************************************
c
      subroutine atlsmear(p,sp,lep)
c*********************************************************************
c
c       this subroutne smears the 3-momentum component of the
c       4-vector p.
c
c       this subroutne is suitable for lhc (atlas)
c
c       input:
c      p   : 4-vector to be smeared (real*8)
c      lep : paricle type, 'e' for electron or photon, 'h' for hadron
c    common /iseed1/ iseed1 : integer seed for random number generator
c
c       output:
c       sp  : smeared 4-vector
c
c*********************************************************************
c
      character*1 lep
      real*8 scalet
      common/ scalet/ scalet
      common/iseed1/ iseed1
      real*8 p(4),sp(4)
c
      diff = p(4)-p(3)
      sum = p(4)+p(3)
      if (abs(diff).lt.1.e-5.or.abs(sum).lt.1.e-5) then
         eta = 20.
      else
         arg = sum/diff
         if (arg.le.0.) then
            eta = 20.
         elseif (arg.gt.0.) then
            eta = abs(.5*log((p(4)+p(3))/(p(4)-p(3))))
         endif
      endif
      et = sqrt(p(1)**2+p(2)**2)
      if (lep.eq.'e') then
         if (eta.lt.2.5) then
            del = sqrt(.095**2/p(4) + 0.005**2 ) * p(4)
         elseif (eta.ge.2.5) then
            del = 0.
         endif
      endif
      if (lep.eq.'m') then
         if (eta.lt.2.) then
            del = sqrt((5.e-4*et)**2+0.012**2)*et*(1.+eta**10/7000.)
         elseif (eta.ge.2.) then
            del = 0.
         endif
      endif

      if (lep.eq.'n') then
         ret = scalet
         del = 0.45*sqrt(ret)
         call rgauss(del,dpx)
         call rgauss(del,dpy)
         sp(1)=p(1)+dpx
         sp(2)=p(2)+dpy
         sp(3)=p(3)
         sp(4)=sqrt(sp(1)**2+sp(2)**2+sp(3)**2)
         goto 15
      endif
      if (lep.eq.'h') then
         if (eta.lt.3.) then
            del = sqrt(.5**2/p(4) + 0.03**2 ) * p(4)
         elseif (eta.ge.3..and.eta.lt.4.5) then
            del = sqrt(1.**2/p(4) + 0.07**2 ) * p(4)
         elseif (eta.ge.4.5) then
            del = 0.
         endif
      endif
 9    call rgauss(del,dp)
      if (p(4).gt.0. .and. dp.gt.-p(4) ) then
         sp(4) = p(4) + dp
         do 10 i=1,3
            sp(i)=p(i)*(1.+dp/p(4))
 10      continue
      else
         sp(4) = 1d-15 * p(4)
         do 11 j=1,3
            sp(j)=1d-15*p(j)
 11      continue
      endif
 15   return
      end
c
c*********************** cmssmear  **************************************
c
      subroutine cmssmear(p,sp,lep)
c***************************************************************************
c
c       this subroutne smears the 3-momentum component of the 4-vector p.
c
c       this subroutne is suitable for lhc (cms)
c
c       input:
c       p   : 4-vector to be smeared (real*8)
c       lep : paricle type, 'e' for electron or photon, 'h' for hadron
c       common /iseed1/ iseed1 : integer seed for random number generator
c
c       output:
c       sp  : smeared 4-vector
c
c***************************************************************************
*
c
      character*1 lep
      common/iseed1/ iseed1
      real*8 p(4),sp(4)
c
      diff = p(4)-p(3)
      sum = p(4)+p(3)
      if (abs(diff).lt.1.e-5.or.abs(sum).lt.1.e-5) then
        eta = 20.
      else
        arg = sum/diff
        if (arg.le.0.) then
          eta = 20.
        elseif (arg.gt.0.) then
          eta = abs(.5*log((p(4)+p(3))/(p(4)-p(3))))
        endif
      endif
      et = sqrt(p(1)**2+p(2)**2)
      if (lep.eq.'e') then
        if (eta.lt.2.6) then
          del = sqrt(.02**2/p(4) + 0.005**2 + 0.15**2/p(4)**2 ) * p(4)
        elseif (eta.ge.2.6) then
          del = 0.
        endif
      endif
      if (lep.eq.'n') then
        del = 0.
        do i=1,2
          sp(i) = p(i)
        end do
        return
      endif
      if (lep.eq.'h') then
        if (eta.lt.2.6) then
          del = sqrt(.52**2/p(4) + 0.015**2 ) * p(4)
        elseif (eta.ge.2.6.and.eta.lt.4.7) then
          del = sqrt(1.25**2/p(4) + 0.05**2 ) * p(4)
        elseif (eta.ge.4.7) then
          del = 0.
        endif
      endif
    9 call rgauss(del,dp)
      if (p(4).gt.0. .and. dp.gt.-p(4) ) then
        sp(4) = p(4) + dp
        do 10 i=1,3
   10   sp(i)=p(i)*(1.+dp/p(4))
      else
        sp(4) = 1d-15 * p(4)
        do 11 j=1,3
   11   sp(j)=1d-15*p(j)
      endif
   15 return
      end
c
c*********************** cdfsmear  
*******************************************
c
      subroutine cdfsmear(p,sp,lep)
c
c***************************************************************************
c
c       this subroutne smears the 3-momentum component of the 4-vector p.
c
c       this subroutine is suitable for tevatron (cdf inspired)
c
c       input:
c       p   : 4-vector to be smeared (real*8)
c       lep : paricle type, 'e' for electron or photon, 'h' for hadron,
c             'n' for missing pt
c       common /iseed1/ iseed1 : integer seed for random number generator
c
c       output:
c       sp  : smeared 4-vector
c
c***************************************************************************
*
c
      character*1 lep
      real*8 scalet
      common/ scalet/ scalet
      common/iseed1/ iseed1
      real*8 p(4),sp(4)
c
      diff = p(4)-p(3)
      sum = p(4)+p(3)
      if (abs(diff).lt.1.e-5.or.abs(sum).lt.1.e-5) then
        eta = 20.
      else
        arg = sum/diff
        if (arg.le.0.) then
          eta = 20.
        elseif (arg.gt.0.) then
          eta = abs(.5*log((p(4)+p(3))/(p(4)-p(3))))
        endif
      endif
      et = sqrt(p(1)**2+p(2)**2)
      if (lep.eq.'e') then
        if (eta.lt.1.2) then
          del=sqrt(.135**2/et + 0.01**2)*p(4)
        elseif (eta.ge.1.2.and.eta.lt.2.4) then
          del=sqrt(.28**2/p(4) + 0.01**2)*p(4)
        elseif (eta.ge.2.4.and.eta.lt.4.2) then
          del=sqrt(.25**2/p(4) + 0.01**2)*p(4)
        elseif (eta.ge.4.2) then
          del=0.
        endif
        goto 9
      endif
      if (lep.eq.'h') then
        if (eta.lt.1.3) then
          del=sqrt(.75**2/et + 0.03**2)*p(4)
        elseif (eta.ge.1.3.and.eta.lt.2.4) then
          del=sqrt(.90**2/p(4) + 0.04**2)*p(4)
        elseif (eta.ge.2.4.and.eta.lt.4.2) then
          del=sqrt(1.30**2/p(4) + 0.04**2)*p(4)
        elseif (eta.ge.4.2) then
          del=0.
        endif
        goto 9
      endif
      if (lep.eq.'n') then
        ret = scalet
        del=.47*sqrt(ret)
        call rgauss(del,dpx)
        call rgauss(del,dpy)
        sp(1)=p(1)+dpx
        sp(2)=p(2)+dpy
        sp(3)=p(3)
        sp(4)=p(4)
        goto 15
      endif

    9 continue
c
c     del fixed at % for test.
c     del=5.

      call rgauss(del,dp)
      if (p(4).gt.0. .and. dp.gt.-p(4) ) then
        sp(4) = p(4) + dp
        do 10 i=1,3
   10   sp(i)=p(i)*(1.+dp/p(4))
      else
        sp(4) = 1d-10 * p(4)
        do 11 j=1,3
   11   sp(j)=1d-10*p(j)
      endif
   15 return
      end
c
c********** d0smear
c
      subroutine d0smear(p,sp,lep)
c
c***************************************************************************
c
c       this subroutne smears the 3-momentum component of the 4-vector p.
c
c       this subroutine is suitable for tevatron (d0 inspired)
c
c       input:
c       p   : 4-vector to be smeared (real*8)
c       lep : particle type, 'e' for electron or photon, 'h' for hadron,
c             'n' for missing pt
c       common /iseed1/ iseed1 : integer seed for random number generator
c
c       output:
c       sp  : smeared 4-vector
c
c***************************************************************************
*
c
      character*1 lep
      real*8 scalet
      common/ scalet/ scalet
      common/iseed1/ iseed1
      real*8 p(4),sp(4)
c
      diff = p(4)-p(3)
      sum = p(4)+p(3)
      if (abs(diff).lt.1.e-5.or.abs(sum).lt.1.e-5) then
        eta = 20.
      else
        arg = sum/diff
        if (arg.le.0.) then
          eta = 20.
        elseif (arg.gt.0.) then
          eta = abs(.5*log((p(4)+p(3))/(p(4)-p(3))))
        endif
      endif
      et = sqrt(p(1)**2+p(2)**2)
      if (lep.eq.'e') then
        c = 0.006
        if (eta.lt.1.3) then
          s = 0.142
        elseif (eta.ge.1.3.and.eta.lt.4.) then
          s = 0.163
        endif
        an = 0.32
        if (eta.lt.4.) then
          del = sqrt( s**2/p(4) + c**2 + (an/p(4))**2 )*p(4)
        elseif (eta.ge.4.) then
          del = 0.
        endif
        goto 9
      endif
      if (lep.eq.'h') then
        del = sqrt(0.5**2/et + 0.05**2)*p(4)
        goto 9
      endif
      if (lep.eq.'n') then
        ret = scalet
        del = 2.94 + 2.86e-05 * ret**2
        call rgauss(del,dpx)
        call rgauss(del,dpy)
        sp(1)=p(1)+dpx
        sp(2)=p(2)+dpy
        sp(3)=p(3)
        sp(4)=p(4)
        goto 15
      endif
    9 call rgauss(del,dp)
      if (p(4).gt.0. .and. dp.gt.-p(4) ) then
        sp(4) = p(4) + dp
        do 10 i=1,3
   10   sp(i)=p(i)*(1.+dp/p(4))
      else
        sp(4) = 1d-10 * p(4)
        do 11 j=1,3
   11   sp(j)=1d-10*p(j)
      endif
   15 return
      end
c
c************************************************************************
c
      subroutine rgauss(del,dp)
c-------yields gaussian distribution of random numbers
      real*4 del,dp
      common/iseed1/ iseed1
      data iseed1 /23147/
      real x(2),csi(2)
      
      if (del.le.0.) then
        dp = 0.
        return
      endif 

 5    continue
c      call randa(2,x)
      call wraprng(x,2)
      
      dp=3*del*(-1.+2*x(1))

      gauss=exp(-dp**2/2./del**2)
      if (x(2)-gauss) 10,10,5
 10   return
      end
c
c*********************** nsmear  ******************************************
c
      subroutine nsmear(p,sp,lep)
c
c***************************************************************************
c
c       this subroutne does not smear
c
c***************************************************************************
*
c
      character*1 lep
      real*8 p(4),sp(4)
      do 1 i=1,4
    1 sp(i) = p(i)
      return
      end

      subroutine metsmear(p,sp)
c
c***************************************************************************
c
c       this subroutine smears the pt-momentum component of the 4-vector p. of
c       a neutrino
c     
c       this subroutine is suitable for tevatron (d0) inspired)
c
c       input:
c       p   : 4-vector to be smeared (real*8)
c       sumet: sum of the et in the event
c
c       output:
c       sp  : smeared 4-vector
c
c***************************************************************************
c
      real*8 p(4),sp(4)
      real*4 x,csi(1)
      real*8 pi
      parameter(pi=3.1415926535987932)

c
      et=sqrt(p(1)**2+p(2)**2)
      del=5.

      call rgauss(del,dp)
c
c     if et=0, then smear in random direction
c
      if(et.eq.0.0)then
 5       continue
 !        call randa(1,x)
         call wraprng(csi,1)
         x = csi(1)
         sp(1)=dp*cos(x*pi)
         sp(2)=dp*sin(x*pi)
      else
         do i=1,2
            sp(i)=p(i)*(1.d0+dp/et)
         end do
      end if
      sp(3)=p(3)
      sp(4)=sqrt(sp(3)**2+sp(2)**2+sp(1)**2)
      return
      
      end

      subroutine et4smear(p,sp)
c
c***************************************************************************
c
c       this subroutne smears the pt-momentum component of the 4-vector p. 
c       by 4 gev in a random direction 
c     
c       this subroutne is suitable for tevatron
c
c       input:
c       p   : 4-vector to be smeared (real*8)
c       sumet: sum of the et in the event
c
c       output:
c       sp  : smeared 4-vector
c
c***************************************************************************
c
      real*8 p(4),sp(4)
      real*4 x,csi(1)
      real*8 pi
      parameter(pi=3.1415926535987932)

      del=4.
      call rgauss(del,dp)
c      call randa(1,x)
      call wraprng(csi,1)
      x = csi(1)
      sp(1)=p(1)+dp*cos(x*pi)
      sp(2)=p(2)+dp*sin(x*pi)
      sp(3)=p(3)
      sp(4)=sqrt(sp(3)**2+sp(2)**2+sp(1)**2)
      return
      
      end
C
C*********************** D0UPGRSMEAR  *****************************************
      subroutine d0upgrsmear(p,sp,lep)
c***************************************************************************
c
c       this subroutine smears the 3-momentum component of the 4-vector p.
c
c       this subroutne is suitable for tevatron (upgraded d0)
c
c       input:
c       p   : 4-vector to be smeared (real*8)
c       lep : paricle type, 'e' for electron or photon, 'h' for hadron,
c             'n' for missing pt
c       common /iseed1/ iseed1 : integer seed for random number generator
c
c       output:
c       sp  : smeared 4-vector
c
c     updated 05/11/95
c
c****************************************************************************
c
      character*1 lep
      real*8 scalet
      common/ scalet/ scalet
      common/iseed1/ iseed1
      real*8 p(4),sp(4)
c
      if (p(4).ne.p(3)) then
        ratio = (p(4)+p(3))/(p(4)-p(3))
        if (ratio.gt.0.) then
          eta = abs(.5*log((p(4)+p(3))/(p(4)-p(3))))
        else
          eta = 10.
        endif
      else
        eta = 10.
      endif
      et = sqrt(p(1)**2+p(2)**2)
c  electrons
      if (lep.eq.'e') then
        c = 0.003
        if (eta.lt.1.3) then
          s = 0.140
          en = 0.140
        elseif (eta.ge.1.3.and.eta.lt.4.) then
          s = 0.157
          en = 0.290
        endif
        if (eta.lt.4.) then
          del = sqrt( (en/p(4))**2 + s**2/p(4) + c**2 )*p(4)
        elseif (eta.ge.4.) then
          del = 0.
        endif
        goto 9
      endif
c  muons
      if (lep.eq.'m') then
        a = 0.015
        b = 0.0016
        if (eta.lt.1.6) then
          del = sqrt( (b*et)**2 + a**2 )*et
        else
          del = 0.
        endif
        goto 9
      endif
c jets
      if (lep.eq.'h') then
        del = sqrt((2.16/et)**2 + 0.74**2/et + 0.01**2)*et
        goto 9
      endif
c missing et
      if (lep.eq.'n') then
        ret = scalet
        del = 1.08 + 0.019 * ret
        call rgauss(del,dpx)
        call rgauss(del,dpy)
        sp(1)=p(1)+dpx
        sp(2)=p(2)+dpy
        sp(3)=p(3)
        sp(4)=sqrt(sp(1)**2+sp(2)**2+sp(3)**2)
        goto 15
      endif
    9 call rgauss(del,dp)
      if (p(4).gt.0. .and. dp.gt.-p(4) ) then
        sp(4) = p(4) + dp
        do 10 i=1,3
   10   sp(i)=p(i)*(1.+dp/p(4))
      else
        sp(4) = 1d-6 * p(4)
        do 11 j=1,3
   11   sp(j)=1d-6*p(j)
      endif
   15 return
      end
