      subroutine recombine_and_smear_Doreen(p3,p4,qph,ie)
      include 'shared.inc'      
      common/ scalet/ scalet ! FOR SMEARING ROUTINES
      dimension q14(4),q14s(4)

      ie = 0
      ismerec = ismear + irec
      if (ismerec.eq.0) return
      scalet = sqrt(p3(1)**2+p3(2)**2) ! FOR SMEARING ROUTINES

      if (lepton.eq.3) then
         print*,'SMEARING AND RECOMBINING NOT DEFINED FOR TAUS!!'
         print*,'STOPPING horace...'
         stop
      endif

!! smearing
      if (ismear.eq.1) then
      if (boson.eq.'W') then
         if (hadr1.eq.hadr2) then ! LHC
            call shiftcomponent(p3,q14,'->')
            if (lepton.eq.1) call atlsmear(q14,q14s,'e')
            if (lepton.eq.2) call atlsmear(q14,q14s,'m')
            call shiftcomponent(p3,q14s,'<-')

            call shiftcomponent(p4,q14,'->')
            call atlsmear(q14,q14s,'n')
            call shiftcomponent(p4,q14s,'<-')
            do k = 1,40
               if (qph(k,0).gt.0.d0) then
                  do i = 0,3
                     ptmp(i) = qph(k,i)
                  enddo
                  call shiftcomponent(ptmp,q14,'->')
                  call atlsmear(q14,q14s,'e')
                  call shiftcomponent(ptmp,q14s,'<-')
                  do i = 0,3
                     qph(k,i) = ptmp(i)
                  enddo
               endif
            enddo

         else                 ! TeVatron
            call shiftcomponent(p3,q14,'->')
            if (lepton.eq.1) call d0upgrsmear(q14,q14s,'e')
            if (lepton.eq.2) call d0upgrsmear(q14,q14s,'m')
            call shiftcomponent(p3,q14s,'<-')

            call shiftcomponent(p4,q14,'->')
            call metsmear(q14,q14s)
            call shiftcomponent(p4,q14s,'<-')

            do k = 1,40
               if (qph(k,0).gt.0.d0) then
                  do i = 0,3
                     ptmp(i) = qph(k,i)
                  enddo
                  call shiftcomponent(ptmp,q14,'->')
                  call d0upgrsmear(q14,q14s,'e')
                  call shiftcomponent(ptmp,q14s,'<-')
                  do i = 0,3
                     qph(k,i) = ptmp(i)
                  enddo
               endif
            enddo
         endif
      else   ! Z
         if (hadr1.eq.hadr2) then ! LHC
            call shiftcomponent(p3,q14,'->')
            if (lepton.eq.1) call atlsmear(q14,q14s,'e')
            if (lepton.eq.2) call atlsmear(q14,q14s,'m')
            call shiftcomponent(p3,q14s,'<-')
            call shiftcomponent(p4,q14,'->')
            if (lepton.eq.1) call atlsmear(q14,q14s,'e')
            if (lepton.eq.2) call atlsmear(q14,q14s,'m')
            call shiftcomponent(p4,q14s,'<-')
            do k = 1,40
               if (qph(k,0).gt.0.d0) then
                  do i = 0,3
                     ptmp(i) = qph(k,i)
                  enddo
                  call shiftcomponent(ptmp,q14,'->')
                  call atlsmear(q14,q14s,'e')
                  call shiftcomponent(ptmp,q14s,'<-')
                  do i = 0,3
                     qph(k,i) = ptmp(i)
                  enddo
               endif
            enddo
         else                 ! TeVatron
            call shiftcomponent(p3,q14,'->')
            if (lepton.eq.1) call d0upgrsmear(q14,q14s,'e')
            if (lepton.eq.2) call d0upgrsmear(q14,q14s,'m')
            call shiftcomponent(p3,q14s,'<-')
            call shiftcomponent(p4,q14,'->')
            if (lepton.eq.1) call d0upgrsmear(q14,q14s,'e')
            if (lepton.eq.2) call d0upgrsmear(q14,q14s,'m')
            call shiftcomponent(p4,q14s,'<-')
            do k = 1,40
               if (qph(k,0).gt.0.d0) then
                  do i = 0,3
                     ptmp(i) = qph(k,i)
                  enddo
                  call shiftcomponent(ptmp,q14,'->')
                  call d0upgrsmear(q14,q14s,'e')
                  call shiftcomponent(ptmp,q14s,'<-')
                  do i = 0,3
                     qph(k,i) = ptmp(i)
                  enddo
               endif
            enddo
         endif
      endif
      endif
!! recombination.... 
      if (irec.eq.1) then
         ipartrec = 1
         call recombine_photons_Doreen(p3,qph,ie)
         ipartrec = 2
         if (boson.eq.'Z') call recombine_photons_Doreen(p4,qph,ie)
      endif
      return
      end
************************************************************
      subroutine recombine_photons_Doreen(p,qph,ierror)
      include 'shared.inc'
      common/ipartrec/ipartrec
      common/irecphot/irecombined(40)
      double precision p(0:3)
     
      ierror = 0
      if (irec.eq.0) return

      etae = pseudorapidity(p)
      phie = getphi(p)
      ee   = p(0)

      re1 = 0.1d0
      re2 = 0.3d0
      re3 = 0.4d0
      rm1 = 0.1d0
      rm2 = 0.4d0

      efr = 0.1d0

      emu1 = 2.d0
      emu2 = 6.d0

      n = 0
!! recombination.... 
      if (lepton.eq.1) then !! if ELECTRON
         do k = 1,40
            iricombinato = 0
            if (qph(k,0).gt.0.d0) then 
               do i = 0,3
                  ptmp(i) = qph(k,i)
               enddo
!!! NO SMEARING FOR ABELIAN CASE....
!               if (ismear.eq.1) call smearing(ptmp,ptmp,1)
!!!
               etag = pseudorapidity(ptmp)
               phig = getphi(ptmp)
               eg   = ptmp(0)
               egmin= efr * ee

               deta = etae - etag
               dphi = phie - phig

               r    = sqrt(deta**2 + dphi**2)
               if (r.lt.re3.and.r.gt.re1.and.eg.gt.egmin) then
                  ierror = 1
                  return
               endif

               if (r.lt.re1) then
                  n = n + 1
                  iricombinato = 1 
                  do i = 0,3
                     p(i) = p(i) + ptmp(i)
                  enddo
               endif
!! se il fotone e' ricombinato, il qph corrispondente viene azzerato...
               if (iricombinato.eq.1) then
                  do ik = 0,3
                     qph(k,ik) = 0.d0
                  enddo
               endif

            endif
         enddo
      else  !! if MUON
         iricombinato = 0
         do k = 1,40
            if (qph(k,0).gt.0.d0) then 
               do i = 0,3
                  ptmp(i) = qph(k,i)
               enddo
               etag = pseudorapidity(ptmp)
               phig = getphi(ptmp)
               eg   = ptmp(0)

               deta = etae - etag
               dphi = phie - phig

               egmin = efr*p(0)
               
               r    = sqrt(deta**2 + dphi**2)
               if (r.lt.rm1.and.eg.gt.emu1) then
                  ierror = 1
                  return
               endif
               if (r.gt.rm1.and.r.lt.rm2.and.eg.gt.egmin) then
                  ierror = 1
                  return
               endif

!! se il fotone e' ricombinato, il qph corrispondente viene azzerato...
               if (iricombinato.eq.1) then
                  do ik = 0,3
                     qph(k,ik) = 0.d0
                  enddo
               endif

            endif
         enddo
      endif
      return
      end
************************
      subroutine recombine_and_smear_leshouches(p3,p4,qph,ie)
      include 'shared.inc'      
      dimension irecombinedtmp(40)
      common/ipartrec/ipartrec
      common/irecphot/irecombined(40)
      common/fordebugging/idebugging
      ie = 0
      ismerec = ismear + irec
      if (ismerec.eq.0) return

      if (lepton.eq.3) then
         print*,'SMEARING AND RECOMBINING NOT DEFINED FOR TAUS!!'
         print*,'STOPPING horace...'
         stop
      endif


!! recombination.... 
      if (irec.eq.1) then
         ipartrec = 1
         call recombine_photons_leshouches(p3,qph)
         ipartrec = 2
         if (boson.eq.'Z') call recombine_photons_leshouches(p4,qph)
      endif
      return
      end
***********************************************
      subroutine recombine_photons_leshouches(pp,qph)
      include 'shared.inc'
      common/fordebugging/idebugging
* Ricombina fotoni ed azzera in qph 
* i quadrimomenti corrispondenti ai fotoni ricombinati
** delta_eta and delta_phi of the calorimenter cluster
      parameter (rmax = 0.1d0)
      dimension pp(0:3),qtmp(0:3),qq(0:3)
! As Dittmaier said, also muons have to be recombined!!
!      if (lepton.ne.1.or.carica.lt.0.5d0) then 
c      carica = abs(charge_factor(3))
c      if (carica.lt.0.5d0) then
c         irec = 0
c         return
c      endif
      icount = 0
      ifot   = 0

      etae = pseudorapidity(pp)
      phie = getphi(pp)
      do k = 1,40
         if (qph(k,0).gt.1.d-12) then
            ifot = ifot + 1
            do i=0,3
               qtmp(i) = qph(k,i)
            enddo
            etag = pseudorapidity(qtmp)
            if (abs(etag).lt.2.5d0) then
               phig = getphi(qtmp)
               de = etae - etag
               dp = phie - phig
               r  = sqrt(de**2 + dp**2)
               if (r.lt.rmax) then
                  icount = icount + 1
                  do i=0,3
                     pp(i)    = pp(i) + qtmp(i)
                     qph(k,i) = 0.d0                 
                  enddo
               endif
            endif
         endif
      enddo
******
      return
      end
*********************************************************
      subroutine recombine_and_smear_ABELIAN(p3,p4,qph,ie)
      include 'shared.inc'      
      dimension irecombinedtmp(40)
      common/ipartrec/ipartrec
      common/irecphot/irecombined(40)
! recombine_and_smear smearava e poi ricombinava.
! Questa routine ricombina e smeara

      ie = 0
      ismerec = ismear + irec
      if (ismerec.eq.0) return

!! recombination.... 
      if (irec.eq.1) then
         ipartrec = 1         
         call recombine_photons_ABELIAN(p3,qph,ie)
         ipartrec = 2
         if (boson.eq.'Z') call recombine_photons_ABELIAN(p4,qph,ie)
      endif


      if (boson.eq.'W') then
         !  lepton smearing....
         if (ismear.eq.1.and.lepton.eq.1) call smearing(p3,p3,1)
         if (ismear.eq.1.and.lepton.eq.2) call smearing(p3,p3,2)
         !  missing momentum smearing
         if (ismear.eq.1) call smearing(p4,p4,3)
      else ! if boson.eq.'Z'
         if (ismear.eq.1) then
           !  leptons smearing....
            if (lepton.eq.1) then
               call smearing(p3,p3,1)
               call smearing(p4,p4,1)
            else                ! if (lepton.eq.2)
               call smearing(p3,p3,2)
               call smearing(p4,p4,2)
            endif
         endif
      endif
      return
      end
*********************************************************
      subroutine recombine_and_smear(p3,p4,qph,ie)
      include 'shared.inc'      
      dimension irecombinedtmp(40)
      common/ipartrec/ipartrec
      common/irecphot/irecombined(40)

      ie = 0
      ismerec = ismear + irec
      if (ismerec.eq.0) return

      if (boson.eq.'W') then
         !  lepton smearing....
         if (ismear.eq.1.and.lepton.eq.1) call smearing(p3,p3,1)
         if (ismear.eq.1.and.lepton.eq.2) call smearing(p3,p3,2)
         !  missing momentum smearing
         if (ismear.eq.1) call smearing(p4,p4,3)
      else ! if boson.eq.'Z'
         if (ismear.eq.1) then
           !  leptons smearing....
            if (lepton.eq.1) then
               call smearing(p3,p3,1)
               call smearing(p4,p4,1)
            else                ! if (lepton.eq.2)
               call smearing(p3,p3,2)
               call smearing(p4,p4,2)
            endif
         endif
      endif
!! recombination.... 
      if (irec.eq.1) then
         ipartrec = 1         
         call recombine_photons(p3,qph,ie)
         ipartrec = 2
         if (boson.eq.'Z') call recombine_photons(p4,qph,ie)
      endif
      return
      end
********************************************************************
      subroutine recombine_photons_dedp(pp,qq,qph)
      include 'shared.inc'
* Ricombina fotoni secondo le specifiche di ATLAS LHC ed azzera in qph 
* i quadrimomenti corrispondenti ai fotoni ricombinati
** delta_eta and delta_phi of the calorimenter cluster
      parameter (deta = 0.075d0)
      parameter (dphi = 0.175d0)
      dimension pp(0:3),qtmp(0:3),qq(0:3)
      carica = abs(charge_factor(3))
      if (lepton.ne.1.or.carica.lt.0.5d0) then 
         irec = 0
         return
      endif
      icount = 0
      ifot   = 0
      if (boson.eq.'W') then
         etae = pseudorapidity(pp)
         phie = getphi(pp)
         do k = 1,40
            if (qph(k,0).gt.0.5d-8) then
               ifot = ifot + 1
               do i=0,3
                  qtmp(i) = qph(k,i)
               enddo
               
               etag = pseudorapidity(ptmp)
               phig = getphi(qtmp)
               
               de = abs(etae - etag)
               dp = abs(phie - phig)
               
               if (de.lt.0.5d0*deta.and.dp.lt.0.5d0*dphi) then
                  icount = icount + 1
                  do i=0,3
                     pp(i)    = pp(i) + qtmp(i)
                     qph(k,i) = 0.d0                 
                  enddo
               endif
            endif
         enddo
******
      else ! if boson eq Z
******
         eta1 = pseudorapidity(pp)
         eta2 = pseudorapidity(qq)
         phi1 = getphi(pp)
         phi2 = getphi(qq)
         do k = 1,40
            if (qph(k,0).gt.0.5d-8) then
               ifot = ifot + 1
               do i=0,3
                  qtmp(i) = qph(k,i)
               enddo

               etag = pseudorapidity(qtmp)
               phig = getphi(qtmp)
               
               de1 = abs(eta1 - etag)
               dp1 = abs(phi1 - phig)
               de2 = abs(eta2 - etag)
               dp2 = abs(phi2 - phig)               
               if (de1.lt.0.5d0*deta.and.dp1.lt.0.5d0*dphi) then
                  icount = icount + 1
                  do i=0,3
                     pp(i)    = pp(i) + qtmp(i)
                     qph(k,i) = 0.d0                 
                  enddo
               endif
               if (de2.lt.0.5d0*deta.and.dp2.lt.0.5d0*dphi) then
                  icount = icount + 1
                  do i=0,3
                     qq(i)    = qq(i) + qtmp(i)
                     qph(k,i) = 0.d0                 
                  enddo
               endif
            endif
         enddo
      endif
      return
      end
***************************************************
      subroutine ricombina(pp,qph)
      include 'shared.inc'
* Ricombina fotoni con angoli < cono ed azzera in qph i quadrimomenti
* corrispondenti ai fotoni ricombinati
      parameter (cono = 5.d0)
      dimension pp(0:3),qtmp(0:3)
      icount = 0
      ifot   = 0
      do k = 1,40
         if (qph(k,0).gt.0.5d-8) then
            ifot = ifot + 1
            do i=0,3
               qtmp(i) = qph(k,i)
            enddo
            angle=
     >          tridot(pp,qtmp)/qtmp(0)/sqrt(pp(1)**2+pp(2)**2+pp(3)**2)

            if (angle.gt.1.d0) angle =  1.d0
	   
            if (angle.lt.-1.d0) angle = -1.d0

            angle=acos(angle)*180.d0/pi

            if (angle.lt.cono) then
               icount = icount + 1
               do i=0,3
                  pp(i)    = pp(i) + qtmp(i)
                  qph(k,i) = 0.d0                 
               enddo
            endif
         endif
      enddo      
      return
      end
*****************************************************
      subroutine smearing(p,pp,itype)
! smearing, from Baur et al........
      include 'shared.inc'
      dimension p(0:3), pp(0:3), pppp(0:3)
!! itype = 1 ---> electron and photon
!! itype = 2 ---> muon
!! itype = 3 ---> missing momentum (neutrino... ;-)  )

      eta = pseudorapidity(p)
      eta = abs(eta)
      et  = sqrt(p(1)**2+p(2)**2)
      del = 0.d0
c  electrons or photons
      if (itype.eq.1) then
         c = 0.003
         if (eta.lt.1.3) then
            s = 0.135            ! see hep-ex/9712029 and
            en = 0.43            !     hep-ex/9908057 (eq. 8)
         elseif (eta.ge.1.3.and.eta.lt.4.) then
            s = 0.157
            en = 0.290
         endif
         if (eta.lt.4.) then
            del = sqrt( (en/p(0))**2 + s**2/et + c**2 )*p(0)
         elseif (eta.ge.4.) then
            del = 0.
         endif
      endif
c  muons
      if (itype.eq.2) then
         a = 0.015
         b = 0.0016
         if (eta.lt.1.6) then
            del = sqrt( (b*et)**2 + a**2 )*et
         else
            del = 0.
         endif       
      endif      
      if (itype.le.2) then
         e_bef = p(0)
	 
	 if (3.d0*del.lt.e_bef) then
!!            print*,'file cutsandinit.f - line 294'
!!            print*,del,e_bef
            call smer(e_bef,del,e_smer)
         else
            e_smer = e_bef
         endif

         p_mod = sqrt(tridot(p,p))

         if (e_smer.lt.0.d0) then
!            print*,'ATTENZIONE!! file cutsandinit.f line 318'
            e_smer = 1.d-8         
         endif

         pp(0) = e_smer
         pp(1) = pp(0)*p(1)/p_mod
         pp(2) = pp(0)*p(2)/p_mod
         pp(3) = pp(0)*p(3)/p_mod
      endif
c missing momentum      
      if (itype.eq.3) then
         del = 5.d0
         call smer(et,del,et_smer)
         pp(1) = p(1) * et_smer/et
         pp(2) = p(2) * et_smer/et
         pp(3) = p(3)
         pp(0) = sqrt(pp(1)**2 + pp(2)**2 + pp(3)**2)
      endif
      return
      end
*******************************************************
      subroutine smer(xmed,sigma,xga)
! Gaussian smearing......
      implicit double precision (a-h,o-z)
      real*4 random(2)
      istop = 0
      do while(istop.eq.0)
         call wraprng(random,2)
         v1 = 2.d0*random(1) - 1.d0
         v2 = 2.d0*random(2) - 1.d0
         s = v1**2+v2**2
         if(s.lt.1) istop = 1
      enddo
      fac =sqrt(-2.d0*log(s)/s)
      gaus = v1*fac
      xga = xmed+sigma*gaus
      return
      end
*******************************************************
      subroutine recombine_photons_ABELIAN(p,qph,ierror)
      include 'shared.inc'
      common/ipartrec/ipartrec
      common/irecphot/irecombined(40)
      double precision p(0:3)
     
      ierror = 0
      if (irec.eq.0) return

      etae = pseudorapidity(p)
      phie = getphi(p)
      ee   = p(0)

      re1 = 0.2d0
      re2 = 0.3d0
      re3 = 0.4d0
      rm1 = 0.2d0
      rm2 = 0.6d0

      efr = 0.15d0

      emu1 = 2.d0
      emu2 = 6.d0

      n = 0
!! recombination.... 
      if (lepton.eq.1) then !! if ELECTRON
         do k = 1,40
            iricombinato = 0
            if (qph(k,0).gt.0.d0) then 
               do i = 0,3
                  ptmp(i) = qph(k,i)
               enddo
!!! NO SMEARING FOR ABELIAN CASE....
!               if (ismear.eq.1) call smearing(ptmp,ptmp,1)
!!!
               etag = pseudorapidity(ptmp)
               phig = getphi(ptmp)
               eg   = ptmp(0)
               egmin= efr * ee

               deta = etae - etag
               dphi = phie - phig

               r    = sqrt(deta**2 + dphi**2)
               if (r.lt.re3.and.r.gt.re1.and.eg.gt.egmin) then
                  ierror = 1
                  return
               endif

               if (r.lt.re1) then
                  n = n + 1
                  iricombinato = 1 
                  do i = 0,3
                     p(i) = p(i) + ptmp(i)
                  enddo
               endif

               if (r.gt.re1.and.r.lt.re2.and.eg.lt.egmin) then
                  n = n + 1
                  iricombinato = 1
                  irecombined(k) = 1
                  do i = 0,3
                     p(i) = p(i) + ptmp(i)
                  enddo
               endif

!! se il fotone e' ricombinato, il qph corrispondente viene azzerato...
               if (iricombinato.eq.1) then
                  do ik = 0,3
                     qph(k,ik) = 0.d0
                  enddo
               endif

            endif
         enddo
      else  !! if MUON
         iricombinato = 0
         do k = 1,40
            if (qph(k,0).gt.0.d0) then 
               do i = 0,3
                  ptmp(i) = qph(k,i)
               enddo
!!! smearing....
!               if (ismear.eq.1) call smearing(ptmp,ptmp,1)
!!!
               etag = pseudorapidity(ptmp)
               phig = getphi(ptmp)
               eg   = ptmp(0)

               deta = etae - etag
               dphi = phie - phig
               
               r    = sqrt(deta**2 + dphi**2)

               if (r.lt.rm1.and.eg.gt.emu1) then
                  ierror = 1
                  return
               endif
               if (r.gt.rm1.and.r.lt.rm2.and.eg.gt.emu2) then
                  ierror = 1
                  return
               endif

!! se il fotone e' ricombinato, il qph corrispondente viene azzerato...
               if (iricombinato.eq.1) then
                  do ik = 0,3
                     qph(k,ik) = 0.d0
                  enddo
               endif

            endif
         enddo
      endif
      return
      end
********************************************************
      subroutine recombine_photons(p,qph,ierror)
      include 'shared.inc'
      common/ipartrec/ipartrec
      common/irecphot/irecombined(40)
      double precision p(0:3)
     
      ierror = 0
      if (irec.eq.0) return

      etae = pseudorapidity(p)
      phie = getphi(p)
      ee   = p(0)

      re1 = 0.2d0
      re2 = 0.3d0
      re3 = 0.4d0
      rm1 = 0.2d0
      rm2 = 0.6d0

      efr = 0.15d0

      emu1 = 2.d0
      emu2 = 6.d0

      n = 0
!! recombination.... 
      if (lepton.eq.1) then !! if ELECTRON
         do k = 1,40
            iricombinato = 0
            if (qph(k,0).gt.0.d0) then 
               do i = 0,3
                  ptmp(i) = qph(k,i)
               enddo
!!! smearing....
               if (ismear.eq.1) call smearing(ptmp,ptmp,1)
!!!
               etag = pseudorapidity(ptmp)
               phig = getphi(ptmp)
               eg   = ptmp(0)
               egmin= efr * ee

               deta = etae - etag
               dphi = phie - phig

               r    = sqrt(deta**2 + dphi**2)
               if (r.lt.re3.and.r.gt.re1.and.eg.gt.egmin) then
                  ierror = 1
                  return
               endif

               if (r.lt.re1) then
                  n = n + 1
                  iricombinato = 1 
                  do i = 0,3
                     p(i) = p(i) + ptmp(i)
                  enddo
               endif

               if (r.gt.re1.and.r.lt.re2.and.eg.lt.egmin) then
                  n = n + 1
                  iricombinato = 1
                  irecombined(k) = 1
                  do i = 0,3
                     p(i) = p(i) + ptmp(i)
                  enddo
               endif


!! se il fotone e' ricombinato, il qph corrispondente viene azzerato...
               if (iricombinato.eq.1) then
                  do ik = 0,3
                     qph(k,ik) = 0.d0
                  enddo
               endif

            endif
         enddo
      else  !! if MUON
         iricombinato = 0
         do k = 1,40
            if (qph(k,0).gt.0.d0) then 
               do i = 0,3
                  ptmp(i) = qph(k,i)
               enddo
!!! smearing....
               if (ismear.eq.1) call smearing(ptmp,ptmp,1)
!!!
               etag = pseudorapidity(ptmp)
               phig = getphi(ptmp)
               eg   = ptmp(0)

               deta = etae - etag
               dphi = phie - phig
               
               r    = sqrt(deta**2 + dphi**2)

               if (r.lt.rm1.and.eg.gt.emu1) then
                  ierror = 1
                  return
               endif
               if (r.gt.rm1.and.r.lt.rm2.and.eg.gt.emu2) then
                  ierror = 1
                  return
               endif


!! se il fotone e' ricombinato, il qph corrispondente viene azzerato...
               if (iricombinato.eq.1) then
                  do ik = 0,3
                     qph(k,ik) = 0.d0
                  enddo
               endif

            endif
         enddo
      endif
      return
      end
****************************************************************************
